/*
 Copyright (C) 2011,2012 Antonio Espinoza
 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
import java.util.Hashtable;
/*
 * This is a resizeable 2D array.
 * It is referenced by any numbers you pick so
 *   15 18  1
 *1  1   2  3
 *2  0   0  6
 *89 4   5  7
 *Is a legit matrix where 15,18,1 are indices into the x 
 *and 1 2 89 are indices into y .
 *Its main use is like a 2D hash table where you give it 2 keys
 *and it returns one value. 
 * */
public class floatResizeArray 
{
	float flt[][];//[row][col]
	private static Hashtable <String, Integer> mToIndex = new Hashtable<String, Integer>(19);
	private static Hashtable <String, Integer> nToIndex = new Hashtable<String, Integer>(19);
	int rowIndex = 0;
	int colIndex = 0;
	public floatResizeArray(int m)
	{
		flt = new float[m][m];
	}
	
	public floatResizeArray()//no input given
	{
		flt = new float[40][40];
	}
	public floatResizeArray(int m, int n)//2 inputs given
	{
		flt = new float[m][n];
	}
	
	public void insert(String m, String n, float v)
	{
		boolean incn = false;
		boolean incm = false;
		if(!mToIndex.containsKey(m))
		{	
			mToIndex.put(m, rowIndex);
			incm = true;
		}
		if(!nToIndex.containsKey(n))
		{
			nToIndex.put(n , colIndex);
			incn = true;
		}
		if(rowIndex>flt.length-1&&incm)
		{
			//expand m | row
			float tmp[][] = new float[flt.length*2][flt[0].length];
			for(int i = 0; i<flt.length;i++)
				for(int j =0;j<flt[0].length;j++)
					tmp[i][j]= flt[i][j];
			flt = tmp;
		}
		if(incn&&colIndex>flt[0].length-1)
		{
			//expand n | col
			float tmp[][] = new float[flt.length][flt[0].length*2];
			for(int i = 0; i<flt.length;i++)
				for(int j =0;j<flt[0].length;j++)
					tmp[i][j]= flt[i][j];
			flt = tmp;
		}
		flt[mToIndex.get(m)][nToIndex.get(n)]= v;
		if(incm)
			rowIndex++;
		if(incn)
			colIndex++;
	}
	public float getItem(String m, String n)
	{
		if(!mToIndex.containsKey(m)||!nToIndex.containsKey(n))
				insert(m,n,0);
		return flt[mToIndex.get(m)][nToIndex.get(n)];
	}
	public void print()
	{
		boolean t = false;
		System.out.print("[");
		for(int i = 0;i<flt.length ; i++)
		{
			t = notZero(flt[i]);
			if(t)
				System.out.print("[");
			
			for(int j = 0;j<flt[0].length ; j++)
				if(t)
					System.out.print(flt[i][j]+" ");
			if(t)
				System.out.print("];");
			t = false;
		}
		System.out.print("];");
	}
	private boolean notZero(float[] fs) 
	{
		boolean t = false;
		for(int i = 0; i<fs.length;i++)
			if(fs[i]!=0)
				return true;
		return t;
	}
}
