/*
 Copyright (C) 2011,2012 Antonio Espinoza
 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Random;

public class ptraceDIFT 
{
	static long gc = 0;
	public final static int dim = 65;
	public final static int wordLen = 32;
	private static Hashtable <String, Regs> registersAndValues = new Hashtable<String, Regs>(19);
	private static Hashtable <String, Regs> nextRegistersAndValues = new Hashtable<String, Regs>(19);
	private static String matchOBIWcReg = "(-??0x\\p{XDigit}+)??\\(%??\\p{Alpha}*,%\\p{Alpha}*,\\p{XDigit}*\\),%\\p{Alpha}*";// ex: (%esi,%ebx,4),%eax
	private static String matchRegcOBIW = "%\\p{Alpha}*,(-??0x\\p{XDigit}+)??\\(%??\\p{Alpha}*,%\\p{Alpha}*,\\p{XDigit}*\\)";// ex: %eax,(%esi,%ebx,4)
	private static String matchNumcReg  = "\\$0x\\p{XDigit}*,%\\p{Alpha}*"; //case($0xa,%reg)
	private static String matchNumcOReg  = "\\$0x\\p{XDigit}*,-??0x\\p{XDigit}*\\(%\\p{Alpha}*\\)"; 
	private static String matchRegcReg = "%\\p{Alpha}*,%\\p{Alpha}*"; //ex: %eip,%eax
	private static String matchRegcOReg = "%\\p{Alpha}*,-??0x\\p{XDigit}*\\(%\\p{Alpha}*\\)";
	private static String matchORegcReg = "-??0x\\p{XDigit}*\\(%\\p{Alpha}*\\),%\\p{Alpha}*"; //case(0x4(%reg),%reg)
	private static String matchAddrcReg = "0x\\p{XDigit}*,%\\p{Alpha}*";
	private static String matchRegcAddr = "%\\p{Alpha}*,0x\\p{XDigit}*";
	private static String matchDRegcReg = "\\(%\\p{Alpha}*\\),%\\p{Alpha}*";
	private static String matchRegcDReg = "%\\p{Alpha}*,\\(%\\p{Alpha}*\\)";
	private static String matchNumcRegA  = "\\$0x\\p{XDigit}*,\\(%\\p{Alpha}*\\)";
	private static String matchNumcAddr  = "\\$0x\\p{XDigit}*,0x\\p{XDigit}*";
	private static String matchNumcOBIW  = "\\$0x\\p{XDigit}*,(-??0x\\p{XDigit}+)??\\(%??\\p{Alpha}*,%\\p{Alpha}*,\\p{XDigit}*\\)";
	private static String matchReg = "%\\p{Alpha}*"; //ex: %eip
	private static String matchNum  = "\\$0x\\p{XDigit}*"; //case($0xa,%reg)
	private static String matchOReg  = "-??0x\\p{XDigit}*\\(%\\p{Alpha}*\\)";
	private static String matchAddr  = "0x\\p{XDigit}*";
	private static floatResizeArray matrix = new floatResizeArray(2,2);
	
	/*Key = eip          
	 * Value = x86 instruction and parameters, if any
	 */
	private static Hashtable <String,String>eipx86 = new Hashtable<String,String>();
	private static Hashtable <String,taintVector>taintVectors = new Hashtable<String,taintVector>();
	/*key is the pointer to memory and value is the taint vector assigned originally */
	private static Hashtable <String,float []>inputTaint = new Hashtable<String,float[]>();
//	private static Hashtable <String,double []>inputTaintComp = new Hashtable<String,double[]>();
	/*
	 * This object Regs is to be used like a pointer so that the Hashtable,
	 * registersAndValues holds one Regs object and indexies it after a particular register
	 * see updateReg:
	 * */
	
	public static void main(String [] args)
	{
		
		String objDumpFile = args[0]+".obj";
		String eips = args[0]+".regs";
		hashInstructions(objDumpFile);
		taintVectors.put("eiz", new taintVector());
		registersAndValues.put("eiz", new Regs(0));
		nextRegistersAndValues.put("eiz", new Regs(0));
		doDIFT(eips);
	}
	private static void doDIFT(String eips) 
	{
		String line,instruction,arg,eip;
		String x86,prevLine;
		try 
		{
			/*Open file that contains the EIPs of the instructions executed for the run of the program
			 * The file also contains every register change associated with the EIP*/
			BufferedReader reader = new BufferedReader(new FileReader(new File(eips)));
			prevLine = reader.readLine();
			updateRegs(prevLine,registersAndValues);
			updateRegs(prevLine,nextRegistersAndValues);
			int c = 0;
			while((line = reader.readLine()) != null)
			{
				c++;
				updateRegs(line,nextRegistersAndValues); 
				eip = prevLine.substring(prevLine.indexOf('[')+1, prevLine.indexOf(']'));
				if (!eipx86.containsKey(eip))
				{
					makeNextRegsCurrentRegs();
					prevLine = new String(line);
					continue;
				}
				/*Get the x86 instruction associated with the EIP*/
				x86 = (String) eipx86.get(eip);
				if(x86.length()<7)
				{
					instruction = x86;
					arg="";
				}
				else
				{
					instruction = x86.substring(0, x86.indexOf(" "));
					arg = x86.substring(x86.indexOf(" "),x86.length()).trim();
				}
				processInstruction(instruction,arg);
				makeNextRegsCurrentRegs();
				prevLine = new String(line);
			}
		} 
		catch (FileNotFoundException e) 
		{
			e.printStackTrace();
		} 
		catch (IOException e) 
		{
			e.printStackTrace();
		}
		matrix.print();
	}
	private static void makeNextRegsCurrentRegs() 
	{
		Enumeration<String> cur = registersAndValues.keys();
		while(cur.hasMoreElements())
		{
			String c = cur.nextElement();
			registersAndValues.get(c).setVal(nextRegistersAndValues.get(c).getVal());
		}
	}
	private static void processInstruction(String instruction, String arg) 
	{
		boolean print = true;
		if(instruction.equals("nop"))
		{
			print = false;
			return;
		}
		if(instruction.equals("call"))
		{
			print = false;
			processCALL(arg);
		}
		if(instruction.equals("jmp"))
			return;
		if(instruction.equals("push"))
		{
			print = false;
			processPUSH(arg);
		}
		if(instruction.equals("pushf"))
		{
			print = false;
			processPUSHF(arg);
		}
		if(instruction.equals("pushl"))
		{
			print = false;
			processPUSHL(arg);
		}
		if(instruction.equals("ret"))
		{
			print = false;
			processRET(arg);
		}
		if(instruction.equals("pop"))
		{
			print = false;
			processPOP(arg);
		}
		if(instruction.equals("jne")) 
		{
			print = false;
			processJNE(arg);
		}
		if(instruction.equals("je"))
		{
			print = false;
			processJNE(arg);
		}
		if(instruction.equals("jz"))
		{
			print = false;
			processJNE(arg);
		}
		if(instruction.equals("jnz"))
		{
			print = false;
			processJNE(arg);
		}
		if(instruction.equals("jl"))
		{
			print = false;
			processJL(arg);
		}
		if(instruction.equals("jae"))
		{
			print = false;
			processJAE(arg);
		}
		if(instruction.equals("jnb"))
		{
			print = false;
			processJAE(arg);
		}
		if(instruction.equals("jb"))
		{
			print = false;
			processJAE(arg);
		}
		if(instruction.equals("jnae"))
		{
			print = false;
			processJAE(arg);
		}
		if(instruction.equals("jc"))
		{
			print = false;
			processJAE(arg);
		}
		if(instruction.equals("jnc"))
		{
			print = false;
			processJAE(arg);
		}
		if(instruction.equals("jnp"))
		{
			print = false;
			processJNP(arg);
		}
		if(instruction.equals("jpo"))
		{
			print = false;
			processJNP(arg);
		}
		if(instruction.equals("jp"))
		{
			print = false;
			processJNP(arg);
		}
		if(instruction.equals("jpe"))
		{
			print = false;
			processJNP(arg);
		}
		if(instruction.equals("jno"))
		{
			print = false;
			processJNO(arg);
		}
		if(instruction.equals("jo"))
		{
			print = false;
			processJNO(arg);
		}
		if(instruction.equals("jns"))
		{
			print = false;
			processJNS(arg);
		}
		if(instruction.equals("js"))
		{
			print = false;
			processJNS(arg);
		}
		if(instruction.equals("jng")) 
		{
			print = false;
			processJNG(arg);
		}
		if(instruction.equals("jle"))
		{
			print = false;
			processJNG(arg);
		}
		if(instruction.equals("jg"))
		{
			print = false;
			processJNG(arg);
		}
		if(instruction.equals("jnle"))
		{
			print = false;
			processJNG(arg);
		}
		if(instruction.equals("ja"))
		{
			print = false;
			processJA(arg);
		}
		if(instruction.equals("jge"))
		{
			print = false;
			processJGE(arg);
		}
		if(instruction.equals("jnl"))
		{
			print = false;
			processJGE(arg);
		}
		if(instruction.equals("jnbe"))
		{
			print = false;
			processJA(arg);
		}
		if(instruction.equals("jbe"))
		{
			print = false;
			processJA(arg);
		}
		if(instruction.equals("jna"))
		{
			print = false;
			processJA(arg);
		}
		if(instruction.equals("mov"))
		{
			print = false;
			processMOV(arg);
		}
		if(instruction.equals("movl"))
		{
			print = false;
			processMOV(arg);
		}
		if(instruction.equals("movb"))
		{
			print = false;
			processMOV(arg);
		}
		if(instruction.equals("movzbl"))
		{
			print = false;
			processMOV(arg);
		}
		if(instruction.equals("movzwl"))
		{
			print = false;
			processMOV(arg);
		}
		if(instruction.equals("movsbl"))
		{
			print = false;
			processMOVSBL(arg);
		}
		if(instruction.equals("cmp"))
		{
			print = false;
			processCMP(arg);
		}
		if(instruction.equals("sub"))
		{
			print = false;
			processSUB(arg);
		}
		if(instruction.equals("subl"))
		{
			print = false;
			processSUBL(arg);
		}
		if(instruction.equals("add"))
		{
			print = false;
			processSUB(arg);
		}
		if(instruction.equals("or"))
		{
			print = false;
			processOR(arg);
		}
		if(instruction.equals("xor"))
		{
			print = false;
			processOR(arg);
		}
		if(instruction.equals("lea"))
		{
			print = false;
			processLEA(arg);
		}
		if(instruction.equals("and"))
		{
			print = false;
			processOR(arg);
		}
		if(instruction.equals("xchg"))
		{
			print = false;
			processXCHG(arg);
		}
		if(instruction.equals("test"))
		{
			print = false;
			processTEST(arg);
		}
		if(instruction.equals("testb"))
		{
			print = false;
			processTESTB(arg);
		}
		if(instruction.equals("testl"))
		{
			print = false;
			processTESTB(arg);
		}
		if(instruction.equals("rep"))
		{
			print = false;
			processREP(arg);
		}
		if(instruction.equals("repnz"))
		{
			print = false;
			processREPNZ(arg);
		}
		if(instruction.equals("not"))
		{
			print = false;
			processNOT(arg);
		}
		if(instruction.equals("notl"))
		{
			print = false;
			processNOTL(arg);
		}
		if(instruction.equals("notb"))
		{
			print = false;
			processNOTL(arg);
		}
		if(instruction.equals("neg"))
		{
			print = false;
			processNEG(arg);
		}
		if(instruction.equals("negl"))
		{
			print = false;
			processNEGL(arg);
		}
		if(instruction.equals("orl"))
		{
			print = false;
			processORL(arg);
		}
		if(instruction.equals("addl"))
		{
			print = false;
			processADDL(arg);
		}
		if(instruction.equals("addb"))
		{
			print = false;
			processADDL(arg);
		}
		if(instruction.equals("andl"))
		{
			print = false;
			processANDL(arg);
		}
		if(instruction.equals("andb"))
		{
			print = false;
			processANDL(arg);
		}
		if(instruction.equals("cmpl"))
		{
			print = false;
			processCMPL(arg);
		}
		if(instruction.equals("cmpw"))
		{
			print = false;
			processCMPL(arg);
		}
		if(instruction.equals("cmpb"))
		{
			print = false;
			processCMPL(arg);
		}
		if(instruction.equals("sete"))
		{
			print = false;
			processSETE(arg);
		}
		if(instruction.equals("setne"))
		{
			print = false;
			processSETE(arg);
		}
		if(instruction.equals("setb"))
		{
			print = false;
			processSETB(arg);
		}
		if(instruction.equals("seta"))
		{
			print = false;
			processSETA(arg);
		}
		if(instruction.equals("setg"))
		{
			print = false;
			processSETG(arg);
		}
		if(instruction.equals("setl"))
		{
			print = false;
			processSETL(arg);
		}
		if(instruction.equals("setbe"))
		{
			print = false;
			processSETBE(arg);
		}
		if(instruction.equals("setle"))
		{
			print = false;
			processSETG(arg);
		}
		if(instruction.equals("setge"))
		{
			print = false;
			processSETL(arg);
		}
		if(instruction.equals("setae"))
		{
			print = false;
			processSETB(arg);
		}
		if(instruction.equals("out"))
		{
			print = false;
			processOUT(arg);
		}
		if(instruction.equals("inc"))
		{
			print = false;
			processINC(arg);
		}
		if(instruction.equals("div"))
		{
			print = false;
			processDIV(arg);
		}
		if(instruction.equals("shl"))
		{                            
			print = false;
			processSHL(arg);
		}
		if(instruction.equals("shld"))
		{                            
			print = false;
			processSHLD(arg);
		}
		if(instruction.equals("sal"))
		{
			print = false;
			processSHL(arg);
		}
		if(instruction.equals("sar"))
		{
			print = false;
			processSHL(arg);
		}
		if(instruction.equals("shr"))
		{
			print = false;
			processSHL(arg);
		}
		if(instruction.equals("cld"))
		{
			print = false;
			processCLD(arg);
		}
		if(instruction.equals("fnstcw"))
		{
			print = false;
//			processFNSTCW(arg);
		}
		if(instruction.equals("leave"))
		{
			print = false;
			processLEAVE(arg);
		}
		if(instruction.equals("mul"))
		{
			print = false;
			processMUL(arg);
		}
		if(instruction.equals("rol"))
		{
			print = false;
			processROL(arg);
		}
		if(instruction.equals("ror"))
		{
			print = false;
			processROL(arg);
		}
		if(instruction.equals("sarl"))
		{
			print = false;
			processSARL(arg);
		}
		if(instruction.equals("imul"))
		{
			print = false;
			processIMUL(arg);
		}
		if(instruction.equals("adcl"))
		{
			print = false;
			processADCL(arg);
		}
		if(instruction.equals("movw"))
		{
			print = false;
			processMOVW(arg);
		}
		if(instruction.equals("fldcw"))
		{
			print = false;
			processFLDCW(arg);
		}
		if(instruction.equals("stmxcsr"))
		{
			print = false;
//			processSTMXCSR(arg);//forget for now
		}
		if(instruction.equals("ldmxcsr"))
		{
			print = false;
//			processLDMXCSR(arg);//forget for now
		}
		if(instruction.equals("sbb"))
		{
			print = false;
			processSBB(arg);//forget for now
		}
		if(instruction.equals("int"))
		{
			print = false;
			processINT(arg);//forget for now
		}
		//if(print)
		//	System.out.println(instruction+arg);
	}
	private static void processPUSHL(String arg) 
	{
		boolean t = false;
		if(arg.matches(matchNum))
		{
			t = true;
			if(!taintVectors.containsKey(Long.toString(registersAndValues.get("esp").getVal()-4)))
				taintVectors.put(Long.toString(registersAndValues.get("esp").getVal()-4), new taintVector());
			
			taintVectors.get(registersAndValues.get("esp").getVal()-4).setVect(
					combineTaintofTwo("eip","esp"));
		}
		if(arg.matches(matchAddr))
		{
			t= true;
			String taddr = Long.toString(Long.parseLong(arg.substring(2), 16));
			String stack = Long.toString(registersAndValues.get("esp").getVal()-4);
			if(!taintVectors.containsKey(stack))
				taintVectors.put(stack, new taintVector());
			
			if(!taintVectors.containsKey(taddr))
				taintVectors.put(taddr, new taintVector());
			taintVectors.get(stack).setVect(
					combineTaintofThree("eip","esp",taddr));
		}
		if(arg.matches(matchOReg))
		{
			t = true;
			String finalD;
			String index;
			long offset;
			String stack = Long.toString(registersAndValues.get("esp").getVal()-4);
			index = arg.substring(arg.indexOf('(')+2, arg.length()-1);
			if(arg.startsWith("-"))
				offset = -1*Long.parseLong(arg.substring(3,arg.indexOf('(')),16);
			else
				offset = Long.parseLong(arg.substring(2,arg.indexOf('(')),16);
			finalD = Long.toString(registersAndValues.get(index).getVal()+offset); 
			if(!taintVectors.containsKey(finalD))
				taintVectors.put(finalD, new taintVector());
			taintVectors.get(stack).setVect(
					combineTaintofFour("eip","esp",finalD,index));
		}
		if(!t)
			System.out.println("processPUSHL:"+arg+registersAndValues.get("eip").getVal());
	}
	private static void processSHLD(String arg) 
	{       
		boolean t = false;
		if(arg.matches(matchNumcReg+","+matchReg));
		{
			StringBuffer b = new StringBuffer(arg);
			b.delete(0, b.indexOf(",")+2);
			String src = b.substring(0,b.indexOf(","));
			b.delete(0, b.indexOf(",")+2);
			String dest = b.substring(0);
			t = true;
			taintVectors.get(src).setVect(combineTaintofTwo(src,dest));
		}
		if(!t)
			System.out.println("processSHLD"+arg);
	}
	private static void processJL(String arg) 
	{
		boolean t = false;
		if(arg.matches("\\p{XDigit}* <.*>"));
		{
			t = true;
			float [] taint = combineTaintofThree("eip","SF","OF");
			taintVectors.get("eip").setVect(taint);
			calcCoorelate("SF","OF");
		}
		if(!t)
			System.out.println("processJL"+arg);
	}
	private static void processSBB(String arg) 
	{
		boolean t = false;
		if(arg.matches(matchRegcReg))
		{
			t = true;
			int commaIdx = arg.indexOf(',');
			StringBuffer src = new StringBuffer(arg.substring(0,commaIdx));
			StringBuffer dest = new StringBuffer(arg.substring(commaIdx+1));
			src.deleteCharAt(0);
			dest.deleteCharAt(0);
			float taint [];
			taint = vectFuncts.combineTaintVectors(taintVectors.get("eip").getVect(),
					vectFuncts.combineTaintVectors(taintVectors.get(dest.toString()).getVect(), 
							vectFuncts.combineTaintVectors(taintVectors.get(src.toString()).getVect(), 
									taintVectors.get("CF").getVect())));
			taintVectors.get(dest.toString()).setVect(taint);
			
			String [] flagNames = {"CF","OF","ZF","PF","SF","AF"};
			for(int i = 0 ;i<flagNames.length;i++)
				taintVectors.get(flagNames[i]).setVect(taint);
		}
		if(!t)
			System.out.println("ProcessSBB"+arg);
	}
	private static void processREPNZ(String arg) 
	{
		boolean t = false;
		if(arg.contains("movsb")&&registersAndValues.get("eip").getVal() == nextRegistersAndValues.get("eip").getVal())
		{
			t= true;
			processMOV("%esi,%edi");
		}
		if(arg.contains("movsl")&&registersAndValues.get("eip").getVal() == nextRegistersAndValues.get("eip").getVal())
		{
			t = true;
			processMOV("%esi,%edi");
		}
		//if(!t)
		//	System.out.printf("REP,%x,%s\n",registersAndValues.get("eip").getVal(),arg);
	}
	private static void processINT(String arg) 
	{
		boolean t= false;
		if(arg.equals("$0x80") && (registersAndValues.get("eax").getVal() == 3))
		{
			long where = registersAndValues.get("ecx").getVal();
			long howMuch = nextRegistersAndValues.get("eax").getVal();
			howMuch = ((howMuch+3) * 8)/32;//the number of words I need to taint
			for( ;howMuch>0;howMuch--)
			{
				makeAndOrTaint(where);
				recordTaint(where);
				where += 32; //update taint position
			}
		}
//		if(!t)
//			System.out.printf("not read,%s:%x\n",arg,registersAndValues.get("eip").getVal());
	}
	private static void recordTaint(long where) 
	{
		String w = Long.toString(where);
		String itWhere = where+":"+gc++;
		inputTaint.put(itWhere, new float [dim]);
		float tvtmp [] = taintVectors.get(w).getVect();
		float ittmp [] = inputTaint.get(itWhere);
		for(int i = 0;i<dim;i++) 
			{
				ittmp[i] = tvtmp[i];
			}
	}
	private static void makeAndOrTaint(long where) 
	{
		String w = Long.toString(where);
		if(!taintVectors.containsKey(w))
			taintVectors.put(w, new taintVector(true));
		else
			taintVectors.get(w).setVect(vectFuncts.getRandomTaintVector());
	}
	private static void processFLDCW(String arg) 
	{
		//ignore for now
	}
	private static void processMOVW(String arg) 
	{
		boolean t = false;
		if(arg.matches(matchNumcOReg))
		{
			t = true;
			String dest = arg.substring(arg.indexOf(',')+1, arg.length());
			String offset = dest.substring(0,dest.indexOf('(')); 
			String index = dest.substring(dest.indexOf('%')+1,dest.length()-1);
			String fd = Long.toString(getFinalD(offset,index));
			if(!taintVectors.containsKey(fd))
				taintVectors.put(fd, new taintVector());
			float tmp [] = vectFuncts.combineTaintVectors(
					taintVectors.get("eip").getVect(), 
					vectFuncts.combineTaintVectors(
							taintVectors.get(index).getVect(), 
							taintVectors.get(fd).getVect()));
			taintVectors.get(fd).setVect(tmp);
		}
		if(!t)
			System.out.printf("ProcessMOVW,%s,%x",arg,registersAndValues.get("eip").getVal());
	}
	private static void processADCL(String arg) 
	{
		boolean t = false;
		float [] tmp = new float[dim];
		if(arg.matches(matchNumcAddr))
		{
			t = true;
			int commaIdx = arg.indexOf(',');
			StringBuffer dest = new StringBuffer(arg.substring(commaIdx+1));
			dest.delete(0, 2);
			String fd = Long.toString(Long.parseLong(dest.toString(),16));
			if(!taintVectors.containsKey(fd))
				taintVectors.put(fd, new taintVector());
			tmp = vectFuncts.combineTaintVectors(
					taintVectors.get("eip").getVect(), 
					vectFuncts.combineTaintVectors(
							taintVectors.get("CF").getVect(), 
							taintVectors.get(fd).getVect()));
			taintVectors.get(fd).setVect(tmp);
		}
		String [] flagNames = {"CF","OF","ZF","PF","SF","AF"};
		for(int i = 0 ;i<flagNames.length;i++)
			taintVectors.get(flagNames[i]).setVect(tmp);
		if(!t)
			System.out.println("processADCL"+arg);
	}
	private static void processIMUL(String arg) 
	{
		boolean t = false;
		if(arg.matches(matchRegcReg))
		{
			t = true;
			int commaIdx = arg.indexOf(',');
			StringBuffer src = new StringBuffer(arg.substring(0,commaIdx));
			StringBuffer dest = new StringBuffer(arg.substring(commaIdx+1));
			src.deleteCharAt(0);
			dest.deleteCharAt(0);
			float[] tmp = vectFuncts.combineTaintVectors(
					taintVectors.get("eip").getVect(), 
					vectFuncts.combineTaintVectors(
							taintVectors.get(dest.toString()).getVect(), 
							taintVectors.get(src.toString()).getVect()));
			taintVectors.get(dest.toString()).setVect(tmp);
		}
		if(arg.matches(matchNum+","+matchRegcReg))//last reg is source!
		{
			t = true;
			StringBuffer sb = new StringBuffer(arg);
			String s1 = sb.substring(0, sb.indexOf(","));
			sb.delete(0, sb.indexOf(",")+1);
			String s2 =  sb.substring(1, sb.indexOf(","));
			sb.delete(0, sb.indexOf(",")+2);
			String dest = sb.toString();
			float [] tmp = vectFuncts.combineTaintVectors(
					taintVectors.get("eip").getVect(),
					taintVectors.get(s2).getVect());
			taintVectors.get(dest).setVect(tmp);
			taintVectors.get("OF").setVect(tmp);
			taintVectors.get("CF").setVect(tmp);
		}
		if(arg.matches(matchORegcReg))
		{
			t = true;
			String offset = arg.substring(0, arg.indexOf("("));
			String base = arg.substring(arg.indexOf("(")+2,arg.indexOf(")"));
			String fd = Long.toString(getFinalD(offset,base));
			String dest = arg.substring(arg.indexOf(',')+2, arg.length());
			if(!taintVectors.containsKey(fd))
				taintVectors.put(fd, new taintVector());
			float [] tmp = vectFuncts.combineTaintVectors(
					taintVectors.get("eip").getVect(), 
					vectFuncts.combineTaintVectors(
							taintVectors.get(fd).getVect(), 
							vectFuncts.combineTaintVectors(
									taintVectors.get(base).getVect(), 
									taintVectors.get(dest).getVect())));
			taintVectors.get(dest).setVect(tmp);
			taintVectors.get("OF").setVect(tmp);
			taintVectors.get("CF").setVect(tmp);
		}
		if(!t)
			System.out.println("processIMUL"+arg);
	}
	private static void processSARL(String arg) 
	{
		boolean t = false;
		if(arg.matches(matchNumcOReg))
		{
			t = true;
			int commaIdx = arg.indexOf(',');
			StringBuffer src = new StringBuffer(arg.substring(0,commaIdx));
			StringBuffer dest = new StringBuffer(arg.substring(commaIdx+1));
			src.delete(0, 3);
			dest.deleteCharAt(0);
			String fd = dest.substring(0, dest.indexOf("("));
			dest.delete(0, dest.indexOf("%")+1);
			dest.deleteCharAt(dest.length()-1);
			long finalD = getFinalD(fd,dest.toString());
			fd = Long.toString(finalD);
			if(!taintVectors.containsKey(finalD))
				taintVectors.put(fd,new taintVector());
			if(taintVectors.get(fd).istainted())
				taintVectors.get("CF").setVect(taintVectors.get(fd).getVect());
			taintVectors.get(fd).setVect(
					vectFuncts.combineTaintVectors(
							taintVectors.get("eip").getVect(), 
							vectFuncts.combineTaintVectors(
									taintVectors.get("SF").getVect(),
									taintVectors.get(fd).getVect())));
		}
		if(!t)
			System.out.printf("processSARL:%s,%x\n",arg,registersAndValues.get("eip").getVal());
	}
	private static void processROL(String arg) 
	{
		boolean t = false;
		float [] tmp = new float[dim];
		if(arg.matches(matchNumcReg))
		{
			t = true;
			int commaIdx = arg.indexOf(',');
			StringBuffer src = new StringBuffer(arg.substring(0,commaIdx));
			StringBuffer dest = new StringBuffer(arg.substring(commaIdx+1));
			src.delete(0, 3);
			dest.deleteCharAt(0);
			tmp = vectFuncts.combineTaintVectors(
					taintVectors.get("eip").getVect(), 
					taintVectors.get(dest.toString()).getVect());
			taintVectors.get("CF").setVect(tmp);
			taintVectors.get(dest.toString()).setVect(tmp);
		}
		if(!t)
			System.out.println("processROL"+arg);
	}
	private static void processMUL(String arg) 
	{
		float tmp [] = new float[dim];
		for(int i = 0 ; i< dim;i++)
			tmp[i]=0;
		boolean t = false;
		if(arg.matches(matchReg))
		{
			t = true;
			tmp = vectFuncts.combineTaintVectors(
					taintVectors.get("eip").getVect(),
					vectFuncts.combineTaintVectors(
							taintVectors.get(arg.substring(1)).getVect(),
							vectFuncts.combineTaintVectors(
									taintVectors.get("eax").getVect(), 
									taintVectors.get("edx").getVect())));
			taintVectors.get("edx").setVect(tmp);
			taintVectors.get("eax").setVect(tmp);
			taintVectors.get("CF").setVect(tmp);
			taintVectors.get("OF").setVect(tmp);
		}
		if(!t)
			System.out.println("processMUL"+arg);
	}
	private static void processLEAVE(String arg) 
	{
		boolean t = false;
		if(arg.length()==0)
		{
			t = true;
			taintVectors.get("esp").setVect(
					vectFuncts.combineTaintVectors(
							taintVectors.get("ebp").getVect(),
							taintVectors.get("eip").getVect()));
			processPOP("%ebp");
		}
		if(!t)
			System.out.println("processLEAVE"+arg);
	}
	private static void processFNSTCW(String arg) 
	{
		boolean t = false;
		if(!t)
			System.out.println("processFNSTCW"+arg);
	}
	private static void processCLD(String arg) 
	{
		boolean t = false;
		if(arg.length() == 0)
		{
			t =true;
			taintVectors.get("DF").clearTaint();
		}
		if(taintVectors.get("eip").istainted())
			taintVectors.get("DF").setVect(taintVectors.get("eip").getVect());
		if(!t)
			System.out.println("processCLD"+arg);
	}
	private static void processSHL(String arg) 
	{
		boolean t = false;
		float [] tmp = new float [dim];
		for(int i = 0;i<dim;i++)
			tmp[i]=0;
		String [] flagNames = {"CF","OF","ZF","PF","SF"};
		for(int i = 0 ;i<flagNames.length;i++)
			taintVectors.get(flagNames[i]).clearTaint();
		if(arg.matches(matchNumcReg))
		{
			t = true;
			int commaIdx = arg.indexOf(',');
			StringBuffer src = new StringBuffer(arg.substring(0,commaIdx));
			StringBuffer dest = new StringBuffer(arg.substring(commaIdx+1));
			src.delete(0, 3);
			dest.deleteCharAt(0);
			if(taintVectors.get("eip").istainted()||taintVectors.get(dest.toString()).istainted())
				tmp = vectFuncts.combineTaintVectors(
						taintVectors.get("eip").getVect(), 
						taintVectors.get(dest.toString()).getVect());
			taintVectors.get(dest.toString()).setVect(tmp);
		}
		if(arg.matches(matchReg))
		{
			t = true;
			int commaIdx = arg.indexOf(',');
			StringBuffer dest = new StringBuffer(arg.substring(commaIdx+1));
			dest.deleteCharAt(0);
			if(taintVectors.get("eip").istainted()||taintVectors.get(dest.toString()).istainted())
				tmp = vectFuncts.combineTaintVectors(
						taintVectors.get("eip").getVect(), 
						taintVectors.get(dest.toString()).getVect());
			taintVectors.get(dest.toString()).setVect(tmp);
		}
		if(arg.matches(matchRegcReg))
		{
			t = true;
			int commaIdx = arg.indexOf(',');
			StringBuffer src = new StringBuffer(arg.substring(0,commaIdx));
			StringBuffer dest = new StringBuffer(arg.substring(commaIdx+1));
			src.deleteCharAt(0);
			dest.deleteCharAt(0);
			
			tmp = vectFuncts.combineTaintVectors(
					taintVectors.get("eip").getVect(), 
					vectFuncts.combineTaintVectors(
							taintVectors.get(src.toString()).getVect(), 
							taintVectors.get(dest.toString()).getVect()));
			
			taintVectors.get(dest.toString()).setVect(tmp);
					
		}
		for(int i = 0 ;i<flagNames.length;i++)
			taintVectors.get(flagNames[i]).setVect(tmp);
		if(!t)
			System.out.printf("processSHL %s, %x\n",arg,registersAndValues.get("eip").getVal());
	}
	private static void processDIV(String arg) 
	{
		boolean t = false;
		float [] tmp = new float[dim];
		String [] flagNames = {"CF","OF","ZF","AF","SF"};
		for(int i = 0 ;i<flagNames.length;i++)
			taintVectors.get(flagNames[i]).clearTaint();
		if(arg.matches(matchReg))
		{
			t = true;
			tmp = vectFuncts.combineTaintVectors(
					taintVectors.get("eip").getVect(), 
					vectFuncts.combineTaintVectors(
					taintVectors.get(arg.substring(1)).getVect(),
					vectFuncts.combineTaintVectors(
					taintVectors.get("eax").getVect(), 
					taintVectors.get("edx").getVect())));
			taintVectors.get("eax").setVect(tmp);
			taintVectors.get("edx").setVect(tmp);
		}
		for(int i = 0 ;i<flagNames.length;i++)
			taintVectors.get(flagNames[i]).setVect(tmp);
		if(!t)
			System.out.println("ProcessDIV"+arg+registersAndValues.get("eip").getVal());
	}
	private static void processMOVSBL(String arg) 
	{
		boolean t = false;
		int commaIdx = arg.indexOf(',');
		StringBuffer src = new StringBuffer(arg.substring(0,commaIdx));
		StringBuffer dest = new StringBuffer(arg.substring(commaIdx+1));
		if(arg.matches(matchRegcReg))
		{
			t = true;
			src.deleteCharAt(0);
			dest.deleteCharAt(0);
			taintVectors.get(dest.toString()).setVect(
					vectFuncts.combineTaintVectors(taintVectors.get("eip").getVect(),  
									taintVectors.get(dest.toString()).getVect()));
		}
		if(arg.matches(matchOReg+","+matchReg))
		{
			t = true;
			dest.deleteCharAt(0);
			String offset = src.substring(0,src.indexOf("(")); 
			String index = src.substring(src.indexOf("(")+2,src.indexOf(")"));
			String finalD = Long.toString(getFinalD(offset,index));
			if(!taintVectors.containsKey(finalD))
				taintVectors.put(finalD, new taintVector());
			taintVectors.get(dest.toString()).setVect(
					vectFuncts.combineTaintVectors(
							taintVectors.get("eip").getVect(), 
							vectFuncts.combineTaintVectors(taintVectors.get(index).getVect(), 
									taintVectors.get(finalD).getVect())));
		}
		if(!t)
			System.out.println("processMOVSBL"+arg);
	}
	private static void processINC(String arg) 
	{
		boolean t = false;
		String []fc = {"OF","SF","ZF","AF","PF"};
		if(arg.matches(matchReg))
		{
			t = true;
			float [] taint = vectFuncts.combineTaintVectors(
					taintVectors.get("eip").getVect(), 
					taintVectors.get(arg.substring(1)).getVect());
			taintVectors.get(arg.substring(1)).setVect(taint);
			for(int i =0;i<fc.length;i++)
				taintVectors.get(fc[i]).setVect(taint);
		}
		if(!t)
			System.out.println("processINC"+arg);
	}
	private static void processNEGL(String arg) 
	{
		boolean t = false;
		
		if(!t)
			System.out.println("processNEGL"+arg);		
	}
	private static void processPUSHF(String arg) 
	{
		boolean t = false;
		
		if(!t)
			System.out.println("processPUSHF"+arg+":"+registersAndValues.get("eip").getVal());
	}
	private static void processNOTL(String arg) 
	{
		boolean t = false;
		if(!t)
			System.out.println("processNOTL"+arg);
	}
	private static void processOUT(String arg) 
	{
		boolean t = false;
		if(!t)
			System.out.println("processOUT"+arg);
	}
	private static void processSETBE(String arg) 
	{
		boolean t = false;
		String dest = arg.substring(1);
		if(arg.matches(matchReg))
		{
			t = true;
			taintVectors.get(dest).setVect(
					vectFuncts.combineTaintVectors(taintVectors.get("eip").getVect(), 
					vectFuncts.combineTaintVectors(taintVectors.get("ZF").getVect(), 
							taintVectors.get("CF").getVect())));
		}
		if(!t)
			System.out.println(arg+"processSETBE");
	} 
	private static void processSETL(String arg) 
	{
		boolean t = false;
		String dest = arg.substring(1);
		if(arg.matches(matchReg))
		{
			t = true;
			taintVectors.get(dest).setVect(
					vectFuncts.combineTaintVectors(taintVectors.get("eip").getVect(), 
					vectFuncts.combineTaintVectors(taintVectors.get("OF").getVect(), 
							taintVectors.get("SF").getVect())));
		}
		if(!t)
			System.out.println("processSETL"+arg);
	}
	private static void processSETG(String arg) 
	{
		boolean t = false;
		String dest = arg.substring(1);
		if(arg.matches(matchReg))
		{
			t = true;
			taintVectors.get(dest).setVect(
					vectFuncts.combineTaintVectors(taintVectors.get("eip").getVect(),
					vectFuncts.combineTaintVectors(taintVectors.get("OF").getVect(), 
					vectFuncts.combineTaintVectors(taintVectors.get("SF").getVect(), 
							taintVectors.get("ZF").getVect()))));
		}
		if(!t)
			System.out.println("processSETG"+arg);
	}
	private static void processSETA(String arg) 
	{
		boolean t = false;
		String dest = arg.substring(1);
		if(arg.matches(matchReg))
		{
			t = true;
			taintVectors.get(dest).setVect(
					vectFuncts.combineTaintVectors(taintVectors.get("eip").getVect(), 
					vectFuncts.combineTaintVectors(taintVectors.get("CF").getVect(), 
							taintVectors.get("ZF").getVect())));
		}
		if(!t)
			System.out.println(arg+"processSETA");
	}
	private static void processSETB(String arg) 
	{
		boolean t = false;
		String dest = arg.substring(1);
		if(arg.matches(matchReg))
		{
			t = true;
			taintVectors.get(dest).setVect(
					vectFuncts.combineTaintVectors(taintVectors.get("CF").getVect(), 
							taintVectors.get("eip").getVect()));
		}
		if(!t)
			System.out.println("processSETB"+arg);
	}
	private static void processSETE(String arg) 
	{
		boolean t = false;
		String dest = arg.substring(1);
		if(arg.matches(matchReg))
		{
			t = true;
			taintVectors.get(dest).setVect(
					vectFuncts.combineTaintVectors(taintVectors.get("ZF").getVect(), 
							taintVectors.get("eip").getVect()));
		}
		if(arg.matches(matchOReg))
		{
			t = true;
			String finalD;
			String index;
			long offset;
			index = arg.substring(arg.indexOf('(')+2, arg.length()-1);
			if(arg.startsWith("-"))
				offset = -1*Long.parseLong(arg.substring(3,arg.indexOf('(')),16);
			else
				offset = Long.parseLong(arg.substring(2,arg.indexOf('(')),16);
			finalD = Long.toString(registersAndValues.get(index).getVal()+offset); 
			if(!taintVectors.containsKey(finalD))
				taintVectors.put(finalD, new taintVector());
			taintVectors.get(finalD).setVect(
					vectFuncts.combineTaintVectors(taintVectors.get("eip").getVect(),
					vectFuncts.combineTaintVectors(taintVectors.get(index).getVect(),
					vectFuncts.combineTaintVectors(taintVectors.get("ZF").getVect(), 
							taintVectors.get(finalD).getVect()))));
		}
		if(!t)
			System.out.println("processSETE"+arg);
	}
	private static void processTESTB(String arg) 
	{
		boolean t = false;
		int commaIdx = arg.indexOf(',');
		StringBuffer src = new StringBuffer(arg.substring(0,commaIdx));
		StringBuffer dest = new StringBuffer(arg.substring(commaIdx+1));
		String [] fn = {"CF","OF","ZF","PF","SF"};
		for(int i = 0 ;i<fn.length;i++)
			taintVectors.get(fn[i]).clearTaint();	
		if(arg.matches(matchNumcOBIW))
		{
			t = true;
			String [] OBIW= vectFuncts.getOBIW(dest);
			String finalD = Long.toString(registersAndValues.get(OBIW[1]).getVal()+
			registersAndValues.get(OBIW[2]).getVal()*Integer.parseInt(OBIW[3], 16) + Integer.parseInt(OBIW[0],16));
			if(!taintVectors.containsKey(finalD))
				taintVectors.put(finalD, new taintVector());
			float [] tmp = combineTaintofFour("eip",OBIW[1],OBIW[2],finalD);
			for(int i = 0;i<fn.length;i++)
				taintVectors.get(fn[i]).setVect(tmp);
		}
		if(arg.matches(matchNumcAddr))//
		{
			t = true;
			dest.delete(0, 2);
			if(!taintVectors.containsKey(dest.toString()))
				taintVectors.put(dest.toString(), new taintVector());
			float [] tmpVect =
					vectFuncts.combineTaintVectors(taintVectors.get(dest.toString()).getVect(), 
							taintVectors.get("eip").getVect());
			taintVectors.get(dest.toString()).setVect(tmpVect);
			for(int i = 0 ;i<fn.length;i++)
				taintVectors.get(fn[i]).setVect(tmpVect);
		}
		if(arg.matches(matchNumcOReg))
		{
			t = true;
			long offset;
			if(dest.charAt(0)=='-')
				offset = -1*Long.parseLong(dest.substring(3, dest.indexOf("(")),16);
			else
				offset = Long.parseLong(dest.substring(2, dest.indexOf("(")),16);
			String index = dest.substring(dest.indexOf("(")+2, dest.length()-1);
			long finalDest = registersAndValues.get(index).getVal() + offset;
			String finalD = Long.toString(finalDest);
			if(!taintVectors.containsKey(finalD))
				taintVectors.put(finalD, new taintVector());
			float tmpVect [] = 
				vectFuncts.combineTaintVectors(taintVectors.get("eip").getVect(), 
						vectFuncts.combineTaintVectors(taintVectors.get(finalD).getVect(), 
					taintVectors.get(index).getVect()));
			for(int i = 0 ;i<fn.length;i++)
				taintVectors.get(fn[i]).setVect(tmpVect);
			taintVectors.get(finalD).setVect(tmpVect);
		}
		if(arg.matches(matchNumcRegA))
		{
			t = true;
			long offset;
			String index = dest.substring(dest.indexOf("(")+2, dest.length()-1);
			long finalDest = registersAndValues.get(index).getVal();
			String finalD = Long.toString(finalDest);
			if(!taintVectors.containsKey(finalD))
				taintVectors.put(finalD, new taintVector());
			float tmpVect [] = 
				vectFuncts.combineTaintVectors(taintVectors.get("eip").getVect(), 
						vectFuncts.combineTaintVectors(taintVectors.get(finalD).getVect(), 
					taintVectors.get(index).getVect()));
			for(int i = 0 ;i<fn.length;i++)
				taintVectors.get(fn[i]).setVect(tmpVect);
			taintVectors.get(finalD).setVect(tmpVect);
		}
		if(!t)
			System.out.println("processTESTB"+arg);
	}
	private static void processJGE(String arg) 
	{
		boolean t = false;
		if(arg.matches("\\p{XDigit}* .*"))
		{
			t = true;
			taintVectors.get("eip").setVect(
					vectFuncts.combineTaintVectors(taintVectors.get("eip").getVect(),
					vectFuncts.combineTaintVectors(taintVectors.get("SF").getVect(),
							taintVectors.get("OF").getVect()))
			);
		}
		calcCoorelate("SF","OF");
		if(!t)
			System.out.println("Process JGE");
	}
	private static void processSUBL(String arg) 
	{
		boolean t = false;
		int commaIdx = arg.indexOf(',');
		StringBuffer src = new StringBuffer(arg.substring(0,commaIdx));
		StringBuffer dest = new StringBuffer(arg.substring(commaIdx+1));
		clearFlags();
		if(arg.matches(matchNumcOReg))
		{
			t = true;
			String index;
			String offset;
			offset = dest.substring(0, dest.indexOf("("));
			index = dest.substring(dest.indexOf("(")+2,dest.length()-1);			
			String finalD = Long.toString(getFinalD(offset,index));
			combineTaintAndSetVector(finalD,"eip", index); 
		}
		if(!t)
			System.out.println("processSUBL"+arg);
	}
	private static void processCMPL(String arg) 
	{
		boolean t = false;
		int commaIdx = arg.indexOf(',');
		StringBuffer src = new StringBuffer(arg.substring(0,commaIdx));
		StringBuffer dest = new StringBuffer(arg.substring(commaIdx+1));
		String [] fc = {"CF","OF","SF","ZF","AF","PF"};
		if(arg.matches(matchNumcRegA))
		{	
			t = true;
			String finalD = Long.toString
			(registersAndValues.get(dest.substring(2,dest.length()-1)).getVal());
			String dReg = dest.substring(2,dest.length()-1);
			if(!taintVectors.containsKey(finalD))
				taintVectors.put(finalD,new taintVector());
			float [] taint = combineTaintofThree("eip",dReg,finalD);
			taintVectors.get(finalD).setVect(taint);
			for(int i = 0;i<fc.length;i++)
				taintVectors.get(fc[i]).setVect(taint);
		}
		if(arg.matches(matchNumcOReg))
		{
			t = true;
			String offset = dest.substring(0, dest.indexOf("("));
			String index = dest.substring(dest.indexOf("(")+2,dest.indexOf(")"));
			String finalD = Long.toString(getFinalD(offset,index));
			if(!taintVectors.containsKey(finalD))
				taintVectors.put(finalD, new taintVector());
			float [] taint = combineTaintofThree("eip",index,finalD);
			taintVectors.get(finalD).setVect(taint);
			for(int i = 0;i<fc.length;i++)
				taintVectors.get(fc[i]).setVect(taint);
		}
		if(arg.matches(matchNumcAddr))
		{
			t = true;
			String finalD = Long.toString(Long.parseLong(dest.substring(3),16));
			if(!taintVectors.containsKey(finalD))
				taintVectors.put(finalD, new taintVector());
			float [] taint = vectFuncts.combineTaintVectors(taintVectors.get("eip").getVect(), 
					taintVectors.get(finalD).getVect());
			taintVectors.get(finalD).setVect(taint);
			for(int i = 0;i<fc.length;i++)
				taintVectors.get(fc[i]).setVect(taint);
		}
		if(arg.matches(".*%gs.*"))
			t = true;
		if(!t)
			System.out.println("processsCMPL"+arg);
	}
	private static void processANDL(String arg) 
	{
		boolean t = false;
		int commaIdx = arg.indexOf(',');
		StringBuffer src = new StringBuffer(arg.substring(0,commaIdx));
		StringBuffer dest = new StringBuffer(arg.substring(commaIdx+1));
		String [] fc = {"OF","CF","SF","ZF","PF"};
		if(arg.matches(matchNumcOReg))
		{
			t = true;
			String offset = dest.substring(0, dest.indexOf("("));
			String index = dest.substring(dest.indexOf("(")+2,dest.indexOf(")"));
			String finalD = Long.toString(getFinalD(offset,index));
			if(!taintVectors.containsKey(finalD))
				taintVectors.put(finalD, new taintVector());
			float [] taint = combineTaintofThree("eip",index,finalD);
			taintVectors.get(finalD).setVect(taint);
			for(int i = 0;i<fc.length;i++)
				taintVectors.get(fc[i]).setVect(taint);
		}
		if(arg.matches(matchNumcRegA))
		{
			t = true;
			String dReg = dest.substring(2,dest.length()-1);
			String finalD = Long.toString
			(registersAndValues.get(dReg).getVal());
			if(!taintVectors.containsKey(finalD))
				taintVectors.put(finalD,new taintVector());
			float [] taint = combineTaintofThree("eip",dReg,finalD);
			taintVectors.get(finalD).setVect(taint);
			for(int i = 0;i<fc.length;i++)
				taintVectors.get(fc[i]).setVect(taint);
		}
		if(arg.matches(matchNumcAddr))
		{
			t = true;
			String finalD = Long.toString(Long.parseLong(dest.substring(3),16));
			if(!taintVectors.containsKey(finalD))
				taintVectors.put(finalD, new taintVector());
			float [] taint = vectFuncts.combineTaintVectors(taintVectors.get("eip").getVect(), 
					taintVectors.get(finalD).getVect());
			taintVectors.get(finalD).setVect(taint);
			for(int i = 0;i<fc.length;i++)
				taintVectors.get(fc[i]).setVect(taint);
		}
		if(!t)
			System.out.println("processANDL"+arg+"eip:"+registersAndValues.get("eip").getVal());
	}
	private static void processADDL(String arg) 
	{
		boolean t = false;
		int commaIdx = arg.indexOf(',');
		StringBuffer src = new StringBuffer(arg.substring(0,commaIdx));
		StringBuffer dest = new StringBuffer(arg.substring(commaIdx+1));
		String [] fc = {"OF","SF","ZF","AF","CF","PF"};
		if(arg.matches(matchNumcOReg))
		{
			t = true;
			String offset = dest.substring(0, dest.indexOf("("));
			String index = dest.substring(dest.indexOf("(")+2, dest.length()-1);
			String finalD = Long.toString(getFinalD(offset,index));
			if(!taintVectors.containsKey(finalD))
				taintVectors.put(finalD, new taintVector());
			float [] taint = combineTaintofThree("eip",index,finalD);
			taintVectors.get(finalD).setVect(taint);
			for(int i = 0;i<fc.length;i++)
				taintVectors.get(finalD).setVect(taint);
		}
		if(arg.matches(matchNumcAddr))
		{
			t = true;
			String finalD = Long.toString(Long.parseLong(dest.substring(2), 16));
			if(!taintVectors.containsKey(finalD))
				taintVectors.put(finalD, new taintVector());
			
			float [] taint = vectFuncts.combineTaintVectors(taintVectors.get("eip").getVect(), 
					taintVectors.get(finalD).getVect());
			
			taintVectors.get(finalD).setVect(taint);
			for(int i = 0;i<fc.length;i++)
				taintVectors.get(finalD).setVect(taint);
		}
		if(!t)
			System.out.println("processADDL"+arg);
	}
	private static void processORL(String arg) 
	{
		boolean t = false;
		int commaIdx = arg.indexOf(',');
		StringBuffer src = new StringBuffer(arg.substring(0,commaIdx));
		StringBuffer dest = new StringBuffer(arg.substring(commaIdx+1));
		String [] fc = {"OF","CF","SF","ZF","PF"};
		if(arg.matches(matchNumcOReg))
		{	
			t = true;
			String offset = dest.substring(0, dest.indexOf("("));
			String index = dest.substring(dest.indexOf("(")+2, dest.length()-1);
			String fd = Long.toString(getFinalD(offset,index));
			if(!taintVectors.containsKey(fd))
				taintVectors.put(fd,new taintVector());
			float [] taint = combineTaintofThree("eip",index,fd);
			taintVectors.get(fd).setVect(taint);
			for(int i =0;i<fc.length;i++)
				taintVectors.get(fc[i]).setVect(taint);
		}
		if(arg.matches(matchNumcRegA))
		{
			t = true;
			String index = dest.substring(dest.indexOf("(")+2, dest.length()-1);
			String fd = Long.toString(registersAndValues.get(index).getVal());
			if(!taintVectors.containsKey(fd))
				taintVectors.put(fd,new taintVector());
			float [] taint = vectFuncts.combineTaintVectors(
					taintVectors.get(fd).getVect(), 
					taintVectors.get(fd).getVect());
			taintVectors.get(fd).setVect(taint);
			for(int i =0;i<fc.length;i++)
				taintVectors.get(fc[i]).setVect(taint);
		}
		if(!t)
			System.out.println("processORL"+arg);
	}
	private static long getFinalD(String offset, String index) 
	{
		long ofst = 0;
		if(offset.charAt(0)=='-') 
		{
			ofst = -1*Long.parseLong(offset.substring(3),16);
		}
		else
		{
			ofst = Long.parseLong(offset.substring(2),16);
		}
		return registersAndValues.get(index).getVal() + ofst;
	}
	private static void processNEG(String arg)
	{
		boolean t = false;
		String dest = arg.substring(1);
		if(arg.matches(matchReg))
		{
			clearFlags();
			t = true;
			String FLAGS []  = {"SF","CF","OF","PF","AF","ZF"};
			for(int i = 0;i<FLAGS.length;i++)
			{
				taintVectors.get(FLAGS[i]).setVect(
						vectFuncts.combineTaintVectors(taintVectors.get(dest).getVect(), 
								taintVectors.get("eip").getVect()));
			}
		}
		if(!t)
			System.out.println("processNEG"+arg);
	}
	private static void processNOT(String arg) 
	{
		boolean t = false;
		if(arg.matches(matchReg))
		{
			t= true;
			if(taintVectors.get("eip").istainted())
				taintVectors.get(arg.substring(1)).setVect(
						vectFuncts.combineTaintVectors(taintVectors.get("eip").getVect(),
								taintVectors.get(arg.substring(1)).getVect()));
		}
		if(!t)
			System.out.println("processNOT"+arg);
	}
	private static void processREP(String arg) 
	{
		boolean t = false;
		if(arg.contains("movsb")&&registersAndValues.get("eip").getVal() == nextRegistersAndValues.get("eip").getVal())
		{
			t= true;
			processMOV("%esi,%edi");
		}
		if(arg.contains("movsl")&&registersAndValues.get("eip").getVal() == nextRegistersAndValues.get("eip").getVal())
		{
			t = true;
			processMOV("%esi,%edi");
		}
	}
	private static void processTEST(String arg) 
	{
		int commaIdx = arg.indexOf(',');
		StringBuffer src = new StringBuffer(arg.substring(0,commaIdx));
		StringBuffer dest = new StringBuffer(arg.substring(commaIdx+1));
		boolean t = false;
		src.deleteCharAt(0);
		dest.deleteCharAt(0);
		String [] fc = {"OF","CF","SF","ZF","PF"};
		if(arg.matches(matchRegcReg))
		{
			t = true;
			float [] taint = combineTaintofThree("eip",src.toString(),dest.toString());
			taintVectors.get(dest.toString()).setVect(taint);
			for(int i = 0 ;i<fc.length;i++)
				taintVectors.get(fc[i]).setVect(taint);
		}
		if(arg.matches(matchNumcReg))
		{
			t = true;
			float [] taint = vectFuncts.combineTaintVectors(
					taintVectors.get("eip").getVect(),
					taintVectors.get(dest.toString()).getVect());
			taintVectors.get(dest.toString()).setVect(taint);
			for(int i = 0 ;i<fc.length;i++)
				taintVectors.get(fc[i]).setVect(taint);
		}
		if(!t)
		{
			System.out.println("processTEST:"+arg);
		}
	}
	private static void processJA(String arg) 
	{
		boolean t = false;
		if(arg.matches("\\p{XDigit}* .*"))
		{
			t = true;
			taintVectors.get("eip").setVect(
					vectFuncts.combineTaintVectors(taintVectors.get("eip").getVect(),
					vectFuncts.combineTaintVectors(taintVectors.get("CF").getVect(),taintVectors.get("ZF").getVect()))
			);
		}
		calcCoorelate("CF","ZF");
		if(!t)
			System.out.println("Process JA");
	}
	private static void processJNG(String arg) 
	{
		boolean t = false;
		if(arg.matches("\\p{XDigit}* .*"))
		{
			t = true;
			taintVectors.get("eip").setVect(
					vectFuncts.combineTaintVectors(taintVectors.get("eip").getVect(),
					vectFuncts.combineTaintVectors(taintVectors.get("ZF").getVect(),
					vectFuncts.combineTaintVectors(taintVectors.get("SF").getVect(),taintVectors.get("OF").getVect())))
			);
			calcCoorelate("ZF","SF","OF");
		}
		if(!t)
			System.out.println("processJNG");
	}
	private static void processJNS(String arg) 
	{
		boolean t = false;
		if(arg.matches("\\p{XDigit}* .*"))
		{
			t = true;
			if(taintVectors.get("SF").istainted())
				combineTaintAndSetVector("eip","SF");
		}
		calcCoorelate("SF");
		if(!t)
			System.out.println("processJNS");
	}
	private static void processJNO(String arg) 
	{
		boolean t = false;
		if(arg.matches("\\p{XDigit}* .*"))
		{
			t = true;
			if(taintVectors.get("OF").istainted())
				combineTaintAndSetVector("eip","OF");
		}
		calcCoorelate("OF");
		if(!t)
			System.out.println("processJNO");
	}
	private static void processJNP(String arg) 
	{
		boolean t = false;
		if(arg.matches("\\p{XDigit}* .*"))
		{
			t = true;
			if(taintVectors.get("PF").istainted())
				combineTaintAndSetVector("eip","PF");
		}
		calcCoorelate("PF");
		if(!t)
			System.out.println("processJNP");
	}
	private static void processJAE(String arg) 
	{
		boolean t = false;
		if(arg.matches("\\p{XDigit}* .*"))
		{
			t = true;
			if(taintVectors.get("CF").istainted())
				combineTaintAndSetVector("eip","CF");
		}
		calcCoorelate("CF");
		if(!t)
			System.out.println("processJNP");
	}
	private static void processCALL(String arg) 
	{
		boolean t = false;
		long sp = registersAndValues.get("esp").getVal();
		sp -= 4;
		String ssp = Long.toString(sp);
		if(arg.matches("\\p{XDigit}* .*"))
		{
			t = true;
			if(taintVectors.containsKey(Long.toString(sp)))
			{
				combineTaintAndSetVector(Long.toString(sp),"eip");
			}
			else
			{
				taintVectors.put(Long.toString(sp), new taintVector());
				combineTaintAndSetVector(Long.toString(sp),"eip");
			}
		}		
		if(arg.matches("\\*\\(%\\p{Alpha}*\\)"))
		{
			t= true;
			String reg = arg.substring(3,arg.length()-1);
			if(!(taintVectors.containsKey(registersAndValues.get(reg).getVal())))
				taintVectors.put(Long.toString(registersAndValues.get(reg).getVal()), new taintVector());
			if(!taintVectors.containsKey(ssp))
				taintVectors.put(ssp, new taintVector());
				taintVectors.get(ssp).setVect(
						vectFuncts.combineTaintVectors(taintVectors.get(ssp).getVect(),
						vectFuncts.combineTaintVectors(taintVectors.get("eip").getVect(),
						vectFuncts.combineTaintVectors(taintVectors.get(reg).getVect(),
						taintVectors.get(Long.toString(registersAndValues.get(reg).getVal())).getVect()))));
			
		}
		if(arg.matches("\\*%\\p{Alpha}*"))
		{
			t=true;
			String reg = arg.substring(2);
			if(!taintVectors.containsKey(ssp))
				taintVectors.put(ssp, new taintVector());
			combineTaintAndSetVectorsOfAllThree(reg,"eip",ssp);
		}
		if(arg.matches("\\*0x\\p{XDigit}*\\(%\\p{Alpha}*\\)"))
		{
			t=true;
			String reg = arg.substring(arg.indexOf('%')+1,arg.length()-1);
			long val = Long.parseLong(arg.substring(3,arg.indexOf('(')), 16);
			String regPval = Long.toString(registersAndValues.get(reg).getVal() + val);
			if(!taintVectors.containsKey(regPval))
				taintVectors.put(regPval, new taintVector());
			if(!taintVectors.containsKey(ssp))
				taintVectors.put(ssp, new taintVector());
			taintVectors.get(ssp).setVect(
			vectFuncts.combineTaintVectors(taintVectors.get("eip").getVect(), 
			vectFuncts.combineTaintVectors(taintVectors.get(ssp).getVect(), 
			vectFuncts.combineTaintVectors(taintVectors.get(reg).getVect(), 
					taintVectors.get(regPval).getVect()))));
		}
		if(arg.matches("\\*0x\\p{XDigit}*"))
		{
			t=true;
			String ar = Long.toString(Long.parseLong(arg.substring(3),16));
			if(!taintVectors.containsKey(ar))
				taintVectors.put(ar, new taintVector());
			if(!taintVectors.containsKey(ssp))
				taintVectors.put(ssp, new taintVector());
			taintVectors.get(ssp).setVect(
			vectFuncts.combineTaintVectors(taintVectors.get("eip").getVect(),
			vectFuncts.combineTaintVectors(taintVectors.get(ar).getVect(), taintVectors.get(ssp).getVect())));
			
		}
		if(arg.matches("\\*0x\\p{XDigit}*\\(,%\\p{Alpha}+,\\p{XDigit}*\\)"))
		{
			StringBuffer argc = new StringBuffer(arg);
			t=true;
			String [] OBIW = new String[4];
			argc.delete(0, 3);
			OBIW[0] = argc.substring(0,argc.indexOf("("));
			argc.delete(0, argc.indexOf("("));
			OBIW[1] = argc.substring(1,argc.indexOf(","));
			argc.delete(0, argc.indexOf(",")+1);
			OBIW[2] = argc.substring(1,argc.indexOf(","));
			argc.delete(0,argc.indexOf(","));
			OBIW[3] = argc.substring(1,argc.indexOf(")"));
			long newta;
			String newtas;
			if(OBIW[1].equals(""))
			{
				newta = registersAndValues.get(OBIW[2]).getVal()*Long.parseLong(OBIW[3], 16)+
				Long.parseLong(OBIW[0], 16);
			}
			else
			{
				newta = registersAndValues.get(OBIW[2]).getVal()*Long.parseLong(OBIW[3], 16)+
				Long.parseLong(OBIW[0], 16) + Long.parseLong(OBIW[1], 16);
			}
			newtas = Long.toString(newta);
			if(!taintVectors.containsKey(ssp))
				taintVectors.put(ssp, new taintVector());
			if(!taintVectors.containsKey(newtas))
				taintVectors.put(newtas, new taintVector());
			taintVectors.get(ssp).setVect(
					vectFuncts.combineTaintVectors(taintVectors.get("eip").getVect(),
					vectFuncts.combineTaintVectors(taintVectors.get(newtas).getVect(), taintVectors.get(ssp).getVect())));
		}
		if(!t)
			System.out.println("processCALL");
	}
	private static void processRET(String arg) 
	{
		boolean t = false;
		if(arg.matches(""))
		{
			t = true;
			taintVectors.get("esp").setVect(taintVectors.get("eip").getVect());
		}
		if(arg.matches("\\$0x\\p{XDigit}*"))
		{
			t = true;
		}
		if(!t)
			System.out.println("ProcessRET");
	}
	private static void processXCHG(String arg) 
	{
		int commaIdx = arg.indexOf(',');
		StringBuffer src = new StringBuffer(arg.substring(0,commaIdx));
		StringBuffer dest = new StringBuffer(arg.substring(commaIdx+1));
		boolean t = false;
		src.deleteCharAt(0);
		dest.deleteCharAt(0);
		if(arg.matches(matchRegcReg))
		{
			t = true;
			taintVector tmp = taintVectors.get(src.toString());
			taintVectors.get(src.toString()).setVect(taintVectors.get(dest.toString()).getVect());
			taintVectors.get(dest.toString()).setVect(tmp.getVect());
		}
		if(!t)
			System.out.println(arg+"processXCHG");
	}
	private static void processPOP(String arg) 
	{
		boolean t = false;
		String argu = arg.substring(1);
		if(arg.matches("%\\p{Alpha}*"))
		{
			t = true;
			if(taintVectors.containsKey(registersAndValues.get("esp").getVal()))
			{
				taintVectors.get(argu).setVect(taintVectors.get(registersAndValues.get("esp").getVal()).getVect());
			}
		}
		if(!t)
			System.out.println("processPOP");
	}
	private static void processPUSH(String arg) 
	{
		boolean t = false;
		if(arg.matches("%\\p{Alpha}*"))
		{
			String argu = arg.substring(1);
			t = true;
			if(!taintVectors.containsKey(Long.toString(registersAndValues.get("esp").getVal()-4)))
				taintVectors.put(Long.toString(registersAndValues.get("esp").getVal()-4), new taintVector());
			
			taintVectors.get(Long.toString(registersAndValues.get("esp").getVal()-4)).setVect(taintVectors.get(argu).getVect());
		}
		if(arg.matches("\\$0x\\p{XDigit}*"))
		{
			t = true;
			String argu = arg.substring(3);
			if(!taintVectors.containsKey(Long.toString(registersAndValues.get("esp").getVal()-4)))
				taintVectors.put(Long.toString(registersAndValues.get("esp").getVal()-4), new taintVector());
			if(!taintVectors.containsKey(argu))
				taintVectors.put(argu,new taintVector());
			taintVectors.get(Long.toString(registersAndValues.get("esp").getVal()-4)).setVect(taintVectors.get(argu).getVect());
		}
		if(taintVectors.get("eip").istainted())
			combineTaintAndSetVector(Long.toString(registersAndValues.get("esp").getVal()-4), "eip");
		if(!t)
			System.out.println("processPUSH");
	}
	private static void processJNE(String arg) 
	{
		boolean t = false;
		if(arg.matches("\\p{XDigit}* .*"))
		{
			t = true;
			if(taintVectors.get("ZF").istainted())
				combineTaintAndSetVector("eip","ZF");
		}
		calcCoorelate("ZF");
		if(!t)
			System.out.println("processJNE");
	}
	private static double simcut = 0.00007;
	private static void calcCoorelate(String reg) 
	{
		Enumeration <String> itt = inputTaint.keys();
		String [] sortedKeys = sortKeys(itt,inputTaint.size());
		float [] tmp;
		float sim ;
		String eipS = Long.toString(registersAndValues.get("eip").getVal());
		String taintName;
		for(int i = 0;i<sortedKeys.length;i++)
		{
			taintName = sortedKeys[i];
			tmp = inputTaint.get(taintName); 
			sim= (float) vectFuncts.cossim(taintVectors.get("eip").getVect(), tmp);
			sim += matrix.getItem(eipS, taintName);
			if(sim > simcut)
				matrix.insert(eipS, taintName , sim);
			else
				matrix.insert(eipS, taintName , 0);
		}
	}
	private static String[] sortKeys(Enumeration<String> it,int len) 
	{
		String [] sorted = new String [len];
		int index;
		String el;
		while(it.hasMoreElements())
		{
			el = it.nextElement();
			index = Integer.parseInt(el.substring(1+el.indexOf(':')));
			sorted[index] = el;
		}
		return sorted;
	}
	private static void calcCoorelate(String reg1,String reg2) 
	{
		Enumeration <String> it = inputTaint.keys();
		String [] sortedKeys = sortKeys(it,inputTaint.size());
		float [] tmp;
		float sim ;
		String eipS = Long.toString(registersAndValues.get("eip").getVal());
		String taintName;
		float [] combregs = vectFuncts.combineTaintVectors(taintVectors.get(reg1).getVect(),
				taintVectors.get(reg2).getVect());
		for(int i = 0;i<sortedKeys.length;i++)
		{
			taintName = sortedKeys[i];
			tmp = inputTaint.get(taintName); 
			sim= (float) vectFuncts.cossim(combregs, tmp);
			if((float) vectFuncts.cossim(taintVectors.get(reg1).getVect(), tmp)> sim)
				sim= (float) vectFuncts.cossim(taintVectors.get(reg1).getVect(), tmp);
			if((float) vectFuncts.cossim(taintVectors.get("eip").getVect(), tmp)> sim)
				sim= (float) vectFuncts.cossim(taintVectors.get(reg2).getVect(), tmp);
			sim += matrix.getItem(eipS, taintName);
			if(sim>simcut)
				matrix.insert(eipS, taintName , sim);
			else
				matrix.insert(eipS, taintName , 0);
		}
	}
	private static void calcCoorelate(String reg1,String reg2,String reg3) 
	{
		Enumeration <String> it = inputTaint.keys();
		String [] sortedKeys = sortKeys(it,inputTaint.size());
		float [] tmp;
		float sim ;
		String eipS = Long.toString(registersAndValues.get("eip").getVal());
		String taintName;
		float [] combregs = vectFuncts.combineTaintVectors(taintVectors.get(reg1).getVect(),
				vectFuncts.combineTaintVectors(taintVectors.get(reg2).getVect(),
						taintVectors.get(reg3).getVect()));
		for(int i = 0;i<sortedKeys.length;i++)
		{
			taintName = sortedKeys[i];
			tmp = inputTaint.get(taintName); 
			sim= (float) vectFuncts.cossim(combregs, tmp);
			sim += matrix.getItem(eipS, taintName);
			if(sim>simcut)
				matrix.insert(eipS, taintName , sim);
			else
				matrix.insert(eipS, taintName , 0);
		}
	}
	private static void processLEA(String arg) 
	{
		int commaIdx = arg.indexOf(',');
		StringBuffer src = new StringBuffer(arg.substring(0,commaIdx));
		StringBuffer dest = new StringBuffer(arg.substring(commaIdx+1));
		boolean t = false;
		
		if(arg.matches(matchORegcReg))
		{
			t = true;
			dest.deleteCharAt(0);
			int delta = vectFuncts.getDeltaAndTrim(src);
			vectFuncts.trimExtra(src);
			taintVector offsetVect = getVectWithOffset(src,delta);
			taintVectWithTaintVector(offsetVect,src.toString(),dest.toString(),dest.toString());
		}
		
		if(arg.matches(matchOBIWcReg))
		{
			t = true;
			int sep = arg.lastIndexOf(",");
			src = new StringBuffer(arg.substring(0, sep));
			dest = new StringBuffer(arg.substring(sep+1, arg.length()));
			dest.deleteCharAt(0);
			String [] OBIW = vectFuncts.getOBIW(src);
			long FinalSource,OFFSET=0;;
			OFFSET = Long.parseLong(OBIW[0]);
			String BASE = OBIW[1];
			String INDEX = OBIW[2];
			int WIDTH = Integer.parseInt(OBIW[3]);
			if(BASE.equals(""))
				FinalSource = (registersAndValues.get(INDEX).val*WIDTH) + OFFSET;
			else
				FinalSource = registersAndValues.get(BASE).getVal()+(registersAndValues.get(INDEX).getVal()*WIDTH)
				+ OFFSET;
			taintVector finalSourceTaintVector = new taintVector();
			taintVector tmp = new taintVector();
			taintVector baseTaintVector;
			if(BASE.equals(""))
				baseTaintVector= new taintVector();
			else
			{
				if(!taintVectors.containsKey(BASE))
					baseTaintVector = taintVectors.get(BASE);
				else
					baseTaintVector = new taintVector();
			}
			if(taintVectors.containsKey(FinalSource))
				finalSourceTaintVector = taintVectors.get(FinalSource);
			else
				taintVectors.put(Long.toString(FinalSource), finalSourceTaintVector);
			tmp.setVect(vectFuncts.combineTaintVectors(baseTaintVector.getVect(),taintVectors.get(INDEX).getVect()));
			tmp.setVect(vectFuncts.combineTaintVectors(tmp.getVect(),finalSourceTaintVector.getVect()));
			taintVectors.get(dest.toString()).setVect(tmp.getVect());
		}
		if(!t)
			System.out.println("processLEA");
	}
	private static void processOR(String arg)
	{
		int commaIdx = arg.indexOf(',');
		StringBuffer src = new StringBuffer(arg.substring(0,commaIdx));
		StringBuffer dest = new StringBuffer(arg.substring(commaIdx+1));
		boolean t = false;
		String [] fc = {"OF","CF","SF","ZF","PF"};
		if(arg.matches(matchRegcReg))
		{
			t = true;
			src.deleteCharAt(0);
			dest.deleteCharAt(0);
			float [] taint = combineTaintofThree("eip",src.toString(),dest.toString());
			taintVectors.get(dest.toString()).setVect(taint);
			for(int i = 0;i<fc.length;i++)
				taintVectors.get(fc[i]).setVect(taint);
		}
		if(arg.matches(matchNumcReg))
		{
			t = true;
			dest.deleteCharAt(0);
			float [] taint = vectFuncts.combineTaintVectors(
					taintVectors.get("eip").getVect(),
					taintVectors.get(dest.toString()).getVect());
			taintVectors.get(dest.toString()).setVect(taint);
			for(int i = 0;i<fc.length;i++)
				taintVectors.get(fc[i]).setVect(taint);
		}
		if(arg.matches(matchRegcOReg))
		{
			t = true;
			String index = dest.substring(dest.indexOf("(")+2,dest.indexOf(")"));
			String offset = dest.substring(0, dest.indexOf("("));
			String finalD = Long.toString(getFinalD(offset,index));
			src.deleteCharAt(0);
			if(!taintVectors.containsKey(finalD))
				taintVectors.put(finalD, new taintVector());
			float [] taint = combineTaintofFour("eip",src.toString(),index,finalD);
			taintVectors.get(finalD).setVect(taint);
			for(int i = 0;i<fc.length;i++)
				taintVectors.get(fc[i]).setVect(taint);
		}
		if(arg.matches(matchORegcReg))
		{
			t=true;
			dest.deleteCharAt(0);
			String offset = src.substring(0,src.indexOf("("));
			String index = src.substring(src.indexOf("(")+2,src.indexOf(")"));
			String finalD = Long.toString(getFinalD(offset,index));
			if(!taintVectors.containsKey(finalD))
				taintVectors.put(finalD, new taintVector());
			float [] taint = combineTaintofFour("eip",dest.toString(),index,finalD);
			taintVectors.get(dest.toString()).setVect(taint);
			for(int i = 0;i<fc.length;i++)
				taintVectors.get(fc[i]).setVect(taint);
		}
		if(arg.matches(".*%gs.*"))
		{
			t= true;
		}
		if(!t)
			System.out.println("processOR"+arg+":"+registersAndValues.get("eip").getVal());
	}
	private static void processSUB(String arg) 
	{
		int commaIdx = arg.indexOf(',');
		StringBuffer src = new StringBuffer(arg.substring(0,commaIdx));
		StringBuffer dest = new StringBuffer(arg.substring(commaIdx+1));
		boolean t = false;
		String [] fc = {"OF","SF","ZF","AF","PF","CF"};
		if(arg.matches(matchNumcReg))
		{
			t = true;
			dest.deleteCharAt(0);
			float [] taint = vectFuncts.combineTaintVectors(taintVectors.get("eip").getVect(),
					taintVectors.get(dest.toString()).getVect());
			taintVectors.get(dest.toString()).setVect(taint);
			for(int i = 0;i<fc.length;i++)
				taintVectors.get(fc[i]).setVect(taint);
		}
		if(arg.matches(matchRegcReg))
		{
			t = true;
			src.deleteCharAt(0);
			dest.deleteCharAt(0);
			float []taint = combineTaintofThree("eip",dest.toString(),src.toString());
			taintVectors.get(dest.toString()).setVect(taint);
			for(int i = 0;i<fc.length;i++)
				taintVectors.get(fc[i]).setVect(taint);
		}
		if(arg.matches(matchORegcReg))
		{
			t = true;
			dest.deleteCharAt(0);
			String offset = src.substring(0,src.indexOf("("));
			String index = src.substring(src.indexOf("(")+2,src.indexOf(")"));
			String finalD = Long.toString(getFinalD(offset,index));
			if(!taintVectors.containsKey(finalD))
				taintVectors.put(finalD, new taintVector());
			float [] taint = combineTaintofFour("eip",dest.toString(),index,finalD);
			taintVectors.get(dest.toString()).setVect(taint);
			for(int i = 0;i<fc.length;i++)
				taintVectors.get(fc[i]).setVect(taint);
		}
		if(arg.matches(matchRegcAddr))
		{
			t = true;
			String finalD = Long.toString(Long.parseLong(dest.substring(2),16));
			src.deleteCharAt(0);
			if(!taintVectors.containsKey(finalD))
				taintVectors.put(finalD,new taintVector());
			float [] taint = combineTaintofThree("eip",src.toString(),finalD);
			taintVectors.get(finalD).setVect(taint);
			for(int i = 0;i<fc.length;i++)
				taintVectors.get(fc[i]).setVect(taint);
		}	
		if(arg.matches(matchRegcOReg))
		{
			t = true;
			String index = dest.substring(dest.indexOf("(")+2,dest.indexOf(")"));
			String offset = dest.substring(0, dest.indexOf("("));
			String finalD = Long.toString(getFinalD(offset,index));
			src.deleteCharAt(0);
			if(!taintVectors.containsKey(finalD))
				taintVectors.put(finalD, new taintVector());
			float [] taint = combineTaintofFour("eip",src.toString(),index,finalD);
			taintVectors.get(finalD).setVect(taint);
			for(int i = 0;i<fc.length;i++)
				taintVectors.get(fc[i]).setVect(taint);
		}
		if(!t)
			System.out.println("processSUB"+registersAndValues.get("eip").getVal()+arg);
	}
	private static void clearFlags() 
	{
		taintVectors.get("OF").clearTaint();
		taintVectors.get("SF").clearTaint();
		taintVectors.get("ZF").clearTaint();
		taintVectors.get("AF").clearTaint();
		taintVectors.get("CF").clearTaint();
		taintVectors.get("PF").clearTaint();
	}
	private static void processCMP(String arg) 
	{
		/*
		OF = Overflow Flag
		CF = Carry Flag
		PF = Parity Flag
		SF = Sign Flag
		AF = Adjust Flag
		ZF = Zero Flag
		*/ 
		int commaIdx = arg.indexOf(',');
		StringBuffer src = new StringBuffer(arg.substring(0,commaIdx));
		StringBuffer dest = new StringBuffer(arg.substring(commaIdx+1));
		String [] fc = {"OF","CF","PF","SF","AF","ZF"};
		if(arg.matches(matchRegcReg))
		{
			dest.deleteCharAt(0);
			src.deleteCharAt(0);
			for(int i = 0;i<fc.length;i++)
				taintVectors.get(fc[i]).setVect(
						combineTaintofThree("eip",src.toString(),dest.toString()));
		}
		if(arg.matches(matchNumcReg))
		{
			dest.deleteCharAt(0);
			for(int i = 0;i<fc.length;i++)
			{
				taintVectors.get(fc[i]).setVect(
						combineTaintofTwo("eip",dest.toString()));
			}
		}
		if(arg.matches(matchRegcOReg))
		{
			src.deleteCharAt(0);
			String offset = dest.substring(0,dest.indexOf("("));
			String index = dest.substring(dest.indexOf("(")+2,dest.indexOf(")"));
			String finalD = Long.toString(getFinalD(offset,index));
			if(!taintVectors.containsKey(finalD))
				taintVectors.put(finalD, new taintVector());
			
			for(int i = 0;i<fc.length;i++)
				taintVectors.get(fc[i]).setVect(
					combineTaintofFour("eip",src.toString(),index,finalD));
		}
		if(arg.matches(matchORegcReg))
		{              
			dest.deleteCharAt(0);
			String offset = src.substring(0,src.indexOf("("));
			String index = src.substring(src.indexOf("(")+2,src.indexOf(")"));
			String finalD = Long.toString(getFinalD(offset,index));
			if(!taintVectors.containsKey(finalD))
				taintVectors.put(finalD, new taintVector());
			for(int i = 0;i<fc.length;i++)
				taintVectors.get(fc[i]).setVect(
					combineTaintofFour("eip",dest.toString(),index,finalD));
		}
		if(arg.matches(matchAddrcReg))
		{              
			src.delete(0,2);
			dest.deleteCharAt(0);
			if(!taintVectors.containsKey(src.toString()))
				taintVectors.put(src.toString(), new taintVector());
			for(int i = 0;i<fc.length;i++)
				taintVectors.get(fc[i]).setVect(combineTaintofThree("eip",src.toString(),dest.toString()));
		}
		if(arg.matches(matchRegcAddr))
		{              
			dest.delete(0,2);
			src.deleteCharAt(0);
			if(!taintVectors.containsKey(dest.toString()))
				taintVectors.put(dest.toString(), new taintVector());
			for(int i = 0;i<fc.length;i++)
					taintVectors.get(fc[i]).setVect(combineTaintofThree("eip",dest.toString(),src.toString()));
		}
		if(arg.matches(matchDRegcReg))
		{              
			dest.deleteCharAt(0);
			src.delete(0,2);
			src.deleteCharAt(src.length()-1);
			if(dest.length()<3)
				dest = new StringBuffer(vectFuncts.get32From16(dest.toString()));
			String finalD = Long.toString(registersAndValues.get(src.toString()).getVal());
			if(!taintVectors.containsKey(finalD))
				taintVectors.put(finalD, new taintVector());
			for(int i = 0;i<fc.length;i++)
				taintVectors.get(fc[i]).setVect(combineTaintofFour("eip",dest.toString(),src.toString(),finalD));
		}
		if(arg.matches(matchRegcDReg))
		{            
			src.deleteCharAt(0);
			dest.delete(0,2);
			dest.deleteCharAt(dest.length()-1);
			if(src.length()<3)
				src = new StringBuffer(vectFuncts.get32From16(src.toString()));
			String finalD = Long.toString(registersAndValues.get(dest.toString()).getVal());
			if(!taintVectors.containsKey(finalD))
				taintVectors.put(finalD, new taintVector());
			for(int i = 0;i<fc.length;i++)
				taintVectors.get(fc[i]).setVect(combineTaintofFour("eip",src.toString(),dest.toString(),finalD));
		}
		if(arg.matches(matchOBIWcReg))
		{ 
			int idx = arg.indexOf("),")+1;
			src = new StringBuffer(arg.substring(0,idx));
			dest = new StringBuffer(arg.substring(idx, arg.length()-1));
			System.out.println(" Src:"+src+" Dest:"+dest);
		}
		if(arg.matches(matchRegcOBIW))
		{ 
			int idx = arg.indexOf("),")+1;
			src = new StringBuffer(arg.substring(0,idx));
			dest = new StringBuffer(arg.substring(idx, arg.length()-1));
			System.out.println(" Src:"+src+" Dest:"+dest);
		}
	}
	private static void taintVectWithTaintVector(taintVector offsetVect, String fst,
			String snd, String finalDest) 
	{
		taintVectors.get(finalDest).setVect(vectFuncts.combineTaintVectors(taintVectors.get(snd).getVect(),
				vectFuncts.combineTaintVectors(offsetVect.getVect(),taintVectors.get(fst).getVect())));
	}
	private static taintVector getVectWithOffset(StringBuffer dest, int delta) 
	{
		String val = Long.toString(registersAndValues.get(dest.toString()).getVal()+delta);
		if(!taintVectors.containsKey(val));
			taintVectors.put(val, new taintVector());	
		return taintVectors.get(val);
	}
	private static void processMOV(String arg) 
	{
		boolean t = false;
		int commaIdx = arg.indexOf(',');
		StringBuffer src = new StringBuffer(arg.substring(0,commaIdx));
		StringBuffer dest = new StringBuffer(arg.substring(commaIdx+1));
		if(arg.matches(matchRegcReg))
		{
			t=true;
			dest.deleteCharAt(0);
			src.deleteCharAt(0);
			if(dest.toString().equals("gs"))
				dest = new StringBuffer("xgs");
			combineTaintAndSetVector(dest.toString(),src.toString());
		}
		if(arg.matches(matchORegcReg))
		{              
			t=true;
			dest.deleteCharAt(0);
			long immediateVal = 0;
			String imV;
			src.delete(0, src.indexOf("x")+1);
			int delta = Integer.parseInt( src.substring(0, src.indexOf("(")), 16 /* radix */ );
			src.delete(0,src.indexOf("%")+1);
			src.deleteCharAt(src.length()-1);
			if (arg.startsWith("-"))
				immediateVal = registersAndValues.get(src.toString()).getVal() - delta;
			else
				immediateVal = registersAndValues.get(src.toString()).getVal() + delta;
			imV = Long.toString(immediateVal);
			if((taintVectors.containsKey(imV)&&taintVectors.get(imV).istainted())
					||taintVectors.get(src.toString()).istainted())
			{
				if(!taintVectors.containsKey(imV))
					taintVectors.put(imV, new taintVector());
				combineTaintAndSetVector(dest.toString(),src.toString(),imV);
			}
			else
				if(taintVectors.get(src.toString()).istainted()&&!taintVectors.contains(imV))
				{
					taintVectors.put(imV, new taintVector());
					combineTaintAndSetVector(dest.toString(),src.toString(),imV);
				}
		}
		if(arg.matches(matchAddrcReg))
		{    
			t=true;
			src.delete(0,2);
			dest.deleteCharAt(0);
			if(taintVectors.contains(src.toString())&&taintVectors.get(src.toString()).istainted())
				combineTaintAndSetVector(dest.toString(),src.toString());
		}
		if(arg.matches(matchNumcReg))
		{
			t=true;
			dest.deleteCharAt(0);
			if(taintVectors.get(dest.toString()).istainted())
				taintVectors.get(dest.toString()).clearTaint();
		}
		if(arg.matches(matchRegcAddr))
		{      
			t=true;
			src.deleteCharAt(0);
			dest.delete(0,2);
			if(taintVectors.get(src.toString()).istainted()&&taintVectors.contains(dest.toString()))
				combineTaintAndSetVector(dest.toString(),src.toString());
			else
			{
				if(taintVectors.get(src.toString()).istainted())
				{
					taintVectors.put(dest.toString(), new taintVector());
					combineTaintAndSetVector(dest.toString(),src.toString());
				}
			}
		}
		if(arg.matches(matchRegcDReg))
		{     
			t=true;
			src.deleteCharAt(0);
			dest.delete(0,2);
			dest.deleteCharAt(dest.length()-1);
			String finalDest = Long.toString(registersAndValues.get(dest.toString()).getVal());
			if( !taintVectors.containsKey(finalDest))
			{                                  
				taintVectors.put(finalDest, new taintVector());
			}
			combineTaintAndSetVectorsOfAllThree(src.toString(),dest.toString(),finalDest);
		}
		/*
		 * Combine the taint of the source and put it in dest
		 * two dependencies in source!
		 * the register itself and what the register points to
		 * example use : (%ebx),%eax
		 * combine taint of %ebx and (%ebx) and store it in %eax
		 * */
		if(arg.matches(matchDRegcReg))
		{      
			t=true;
			dest.deleteCharAt(0);
			src.delete(0,2);
			src.deleteCharAt(src.length()-1);
			String source = new Long(registersAndValues.get(src.toString()).getVal()).toString();
			if( !taintVectors.containsKey(source))
			{                                  
				taintVectors.put(source, new taintVector());
			}
			combineTaintAndSetVector(dest.toString(),source,src.toString());
		}
		if(arg.matches(matchRegcOReg))
		{     
			t=true;
			boolean pos = !dest.toString().startsWith("-");
			src.deleteCharAt(0);
			dest.delete(0, dest.indexOf("x")+1);
			int delta = Integer.parseInt(dest.substring(0, dest.indexOf("(")),16);
			long finalDest;
			dest.delete(0, dest.indexOf("%")+1);
			dest.deleteCharAt(dest.length()-1);
			if(pos)
				finalDest = delta + registersAndValues.get(dest.toString()).getVal();
			else
				finalDest = delta - registersAndValues.get(dest.toString()).getVal();
			if(!taintVectors.containsKey((Long.toString(finalDest))))
				taintVectors.put(Long.toString(finalDest), new taintVector());
			combineTaintAndSetVector(Long.toString(finalDest),dest.toString(),src.toString());
		}
		if(arg.matches(matchOBIWcReg))
		{
			t=true;
			int idx = arg.lastIndexOf(',');
			src = new StringBuffer(arg.subSequence(0, idx));
			src.delete(0,2);
			dest = new StringBuffer(arg.subSequence(idx+2,arg.length()));
			long OFFSET=0;
			long FinalSource;
			String [] OBIW = vectFuncts.getOBIW(src,arg);
			OFFSET = Long.parseLong(OBIW[0]);
			String BASE = OBIW[1];
			String INDEX = OBIW[2];
			int WIDTH = Integer.parseInt(OBIW[3]);
			if(BASE.equals(""))
				FinalSource = (registersAndValues.get(INDEX).getVal()*WIDTH) + OFFSET;
			else
				FinalSource = registersAndValues.get(BASE).getVal()+(registersAndValues.get(INDEX).getVal()*WIDTH)
				+ OFFSET;
			taintVector finalSourceTaintVector = new taintVector();
			taintVector tmp = new taintVector();
			taintVector baseTaintVector;
			if(BASE.equals(""))
				baseTaintVector= new taintVector();
			else
			{
				if(!taintVectors.containsKey(BASE))
					baseTaintVector = taintVectors.get(BASE);
				else
					baseTaintVector = new taintVector();
			}
			if(taintVectors.containsKey(FinalSource))
				finalSourceTaintVector = taintVectors.get(FinalSource);
			else
				taintVectors.put(Long.toString(FinalSource), finalSourceTaintVector);
			tmp.setVect(vectFuncts.combineTaintVectors(baseTaintVector.getVect(),taintVectors.get(INDEX).getVect()));
			tmp.setVect(vectFuncts.combineTaintVectors(tmp.getVect(),finalSourceTaintVector.getVect()));
			taintVectors.get(dest.toString()).setVect(tmp.getVect());
		}
		
		if(arg.matches(matchRegcOBIW))
		{
			t=true; 
			String [] OBIW = vectFuncts.getOBIW(dest);
			long finalDest = registersAndValues.get(OBIW[1]).getVal() + 
			registersAndValues.get(OBIW[2]).getVal()*Integer.parseInt(OBIW[3])+Long.parseLong(OBIW[0]); 
			
			src.deleteCharAt(0);
			
			if(taintVectors.get(src.toString()).istainted()||taintVectors.get(OBIW[1]).istainted()||
					taintVectors.get(OBIW[2]).istainted())
			{
				taintVector tmp = new taintVector();
				tmp.setVect(vectFuncts.combineTaintVectors(taintVectors.get(OBIW[1]).getVect(),
						taintVectors.get(OBIW[2]).getVect()));
				tmp.setVect(vectFuncts.combineTaintVectors(tmp.getVect(),taintVectors.get(src.toString()).getVect()));
				if(taintVectors.containsKey(Long.toString(finalDest)))
					taintVectors.get(Long.toString(finalDest)).setVect(tmp.getVect());
				else
					taintVectors.put(Long.toString(finalDest), tmp);
			}
			dest = new StringBuffer(Long.toString(finalDest));
		}
		if(arg.matches("%\\p{Alpha}+\\:0x\\p{XDigit}+,%\\p{Alpha}+"))
		{
			t=true;
			src.deleteCharAt(0);
			dest.deleteCharAt(0);
			String srcaddr = "x"+src.substring(0,src.indexOf(":"));
			src.delete(0, src.indexOf(":")+1);
			if(src.charAt(0)=='0')
				src.delete(0,2);
			int offset = Integer.parseInt(src.toString(),16);
			
			long finalSource = registersAndValues.get(srcaddr).getVal() + offset;
			
			taintVectors.put(Long.toString(finalSource), new taintVector());
			combineTaintAndSetVector(dest.toString(),Long.toString(finalSource),srcaddr);
		}
		if(arg.matches("%\\p{Alpha}+,%\\p{Alpha}+\\:0x\\p{XDigit}+"))
		{
			t=true;
			dest.deleteCharAt(0);
			src.deleteCharAt(0);
			String srcaddr = "x"+dest.substring(0,dest.indexOf(":"));
			dest.delete(0, dest.indexOf(":")+1);
			if(dest.charAt(0)=='0')
				dest.delete(0,2);
			int offset = Integer.parseInt(dest.toString(),16);
			long finalDest = registersAndValues.get(srcaddr).getVal() + offset;
			if(taintVectors.get(srcaddr).istainted()||taintVectors.get(src.toString()).istainted())
			{
				if(!taintVectors.containsKey(Long.toString(finalDest)))
					taintVectors.put(Long.toString(finalDest), new taintVector());
				combineTaintAndSetVector(Long.toString(finalDest),srcaddr,src.toString());
			}
			dest = new StringBuffer(Long.toString(finalDest));
		}
		if(arg.matches(matchNumcOReg))
		{
			t = true;
			long offset = 0;
			long finalDest = 0;
			if(dest.charAt(0)=='-')
			{
				dest.delete(0, 3);
				offset = -1*Integer.parseInt(dest.substring(0, dest.indexOf("(")), 16);
			}
			else
			{
				dest.delete(0, 2);
				offset = Integer.parseInt(dest.substring(0, dest.indexOf("(")), 16);
			}
			dest.delete(0, dest.indexOf("(")+2);
			dest.deleteCharAt(dest.length()-1);
			finalDest = registersAndValues.get(dest.toString()).getVal() + offset;
			if(taintVectors.containsKey(Long.toString(finalDest)) &&
					taintVectors.get(Long.toString(finalDest)).istainted())
				taintVectors.get(Long.toString(finalDest)).clearTaint();
			dest = new StringBuffer(Long.toString(finalDest));
		}
		if(arg.matches(matchNumcRegA)) 
		{
			t = true;
			dest.delete(0, 2);
			dest.deleteCharAt(dest.length()-1);
			if(taintVectors.containsKey(registersAndValues.get(dest.toString())) &&
					taintVectors.get(registersAndValues.get(dest.toString())).istainted())
				taintVectors.get(dest.toString()).clearTaint();
			dest = new StringBuffer(Long.toString(registersAndValues.get(dest.toString()).getVal()));
		}
		
		if(arg.matches(matchNumcAddr))
		{
			t = true;
			dest.delete(0, 2);
			String finalDest = Long.toString(Long.parseLong(dest.toString(), 16));
			if(taintVectors.containsKey(finalDest) &&taintVectors.get(finalDest).istainted())
				taintVectors.get(finalDest).clearTaint();
			dest = new StringBuffer(finalDest);
		}
		if(arg.matches(matchNumcOBIW))
		{
			t = true;
			String OBIW [] = vectFuncts.getOBIW(dest);
			Long finalDest = vectFuncts.getFinalDest(Long.parseLong(OBIW[0],16)
					,registersAndValues.get(OBIW[1]).getVal(),registersAndValues.get(OBIW[2]).getVal(),
					Long.parseLong(OBIW[3],16));
			String fd = Long.toString(finalDest);
			if(!taintVectors.containsKey(fd))
				taintVectors.put(fd, new taintVector());
			taintVectors.get(fd).setVect(
					vectFuncts.combineTaintVectors(taintVectors.get(OBIW[1]).getVect(), 
							taintVectors.get(OBIW[2]).getVect()));
			dest = new StringBuffer(fd);
		}
		if(!t)
			System.out.println("\""+arg+"\"");
		if(taintVectors.get("eip").istainted())
		{
			if(dest.toString().matches("\\p{XDigit}*"))
			{
				dest = new StringBuffer(Long.toString(Long.parseLong(dest.toString(), 16)));
				if(!taintVectors.containsKey(dest.toString()))
					taintVectors.put(dest.toString(), new taintVector());
			}
			combineTaintAndSetVector(dest.toString(),"eip");
		}
	}
	/*
	 * Combines the taint of all three vectors and stores it in the dest taint vector
	 * this should combine the taint of dest and source2 first
	 * then combine that taint with taint of source1
	 * example use : mov %ebx,(%esp)
	 * where %ebx = source 1
	 *       %esp = source 2
	 *       (esp)= dest
	 * and (esp) is the value %esp holds which is the memory address the ebx will be stored 
	 * */
	private static void combineTaintAndSetVectorsOfAllThree(String source1,
			String source2, String dest) 
	{
		float [] tmp = new float[dim];
		if(taintVectors.get(dest).istainted())
			tmp = vectFuncts.combineTaintVectors(taintVectors.get(dest).getVect(),taintVectors.get(source2).getVect());
		
		tmp = vectFuncts.combineTaintVectors(tmp,taintVectors.get(source1).getVect());
		taintVectors.get(dest).setVect(tmp);
	}
	private static float [] combineTaintofFour(String s1,String s2,String s3,String s4)
	{
		float [] tmp = new float [dim];
		tmp = vectFuncts.combineTaintVectors(taintVectors.get(s1).getVect(),
				vectFuncts.combineTaintVectors(taintVectors.get(s2).getVect(), 
						vectFuncts.combineTaintVectors(taintVectors.get(s3).getVect(), 
								taintVectors.get(s4).getVect())));
		return tmp;
	}
	private static float [] combineTaintofThree(String s1,String s2,String s3)
	{
		float [] tmp = new float [dim];
		tmp = vectFuncts.combineTaintVectors(taintVectors.get(s1).getVect(), 
				vectFuncts.combineTaintVectors(taintVectors.get(s2).getVect(),
						taintVectors.get(s3).getVect()));
		return tmp;
	}
	private static float [] combineTaintofTwo(String s1,String s2)
	{
		float [] tmp = new float [dim];
		tmp = vectFuncts.combineTaintVectors(taintVectors.get(s1).getVect(),
						taintVectors.get(s2).getVect());
		return tmp;
	}
	private static void combineTaintAndSetVector(String dest,String source1, String source2) 
	{
		taintVectors.get(dest).setVect(vectFuncts.combineTaintVectors(
				taintVectors.get(source1).getVect(),
				taintVectors.get(source2).getVect()));
	}
	private static void combineTaintAndSetVector(String dest,String source) 
	{
		taintVectors.get(dest).setVect(vectFuncts.combineTaintVectors(
				taintVectors.get(dest).getVect(),
				taintVectors.get(source).getVect()));
	}
	private static void updateRegs(String line, Hashtable<String, Regs> rav) 
	{
		StringBuffer sb = new StringBuffer(line);
		int endIdx =line.indexOf(']');
		long val;
		String reg;
		updateReg("eip",Long.parseLong(sb.substring(1,endIdx),16),rav);
		sb.delete(0,endIdx+1);
		while(sb.length()>0)
		{
			endIdx =sb.indexOf("]");
			reg = sb.substring(0, sb.indexOf("="));
			val = Long.parseLong(sb.substring(sb.indexOf("[")+1, endIdx),16);
			sb.delete(0, endIdx+1);
			updateReg(reg,val,rav);
		}
		Enumeration<String> x = registersAndValues.keys();
		while(x.hasMoreElements())
		{
			String t = x.nextElement();
		}
	}
	private static void updateReg(String reg, long val, Hashtable<String, Regs> rav) 
	{
		if(rav.containsKey(reg))
			rav.get(reg).setVal(val);
		else
		{
			taintVectors.put(reg, new taintVector());
			if(reg.matches("e[abcd]x"))
			{
				String gpr = reg.substring(1,2);
				taintVector tmp = taintVectors.get(reg);
				taintVectors.put(gpr+"l", tmp);
				taintVectors.put(gpr+"h", tmp);
				taintVectors.put(gpr+"x", tmp);
			}
			rav.put(reg, new Regs(val));
		}
	}
	String getInstruction(int eip)
	{
	return null;	
	}
	static void hashInstructions(String filename)
	{
		try 
		{
			String line;
			int pivot;
			int len;
			BufferedReader reader = new BufferedReader(new FileReader(new File(filename)));
			while((line = reader.readLine()) != null)
			{
				pivot = line.indexOf(":");
				len = line.length();
				if (pivot < 0 || pivot+24>len)
					continue;
				String key = line.substring(0,pivot).trim();
				String value = line.substring(pivot+24,len);
				eipx86.put(key, value);			
			}
		} 
		catch (FileNotFoundException e) 
		{
			e.printStackTrace();
		} 
		catch (IOException e) 
		{
			e.printStackTrace();
		}
		/*
		 * Needed to put the flags into the taint vector 
		 * somewhere where it would only be done once
		 * this seemed as good a place as any
		 * */
		taintVectors.put("OF", new taintVector());
		taintVectors.put("CF", new taintVector());
		taintVectors.put("PF", new taintVector());
		taintVectors.put("SF", new taintVector());
		taintVectors.put("AF", new taintVector());
		taintVectors.put("ZF", new taintVector());
		taintVectors.put("DF", new taintVector());
	}
	/*Prints all unique instructions in the program
	 * useful for instrumenting :)*/
	private static void printAllUniqueInstructions() 
	{
		Collection<String> x = eipx86.values();
		String instruction;
		String[] y = x.toArray(new String[0]);
		ArrayList <String> al = new ArrayList<String>();

		int idx;
		for(int i=0;i<y.length;i++)
		{
			idx = y[i].indexOf(" ");
			if (idx > -1)
				instruction = y[i].substring(0, idx);
			else 
				instruction = y[i];
			if(al.contains(instruction))
				continue;
			al.add(instruction);
			System.out.println(instruction);
		}
	}
	private static void printRegs(Hashtable <String, Regs> ht)
	{
		Enumeration<String> e = ht.keys();
		while(e.hasMoreElements())
		{
			String t = e.nextElement();
			System.out.printf("%s:%x,",t,ht.get(t).getVal());
		}
		System.out.print("\n");
	}
	private static String [] flagsChangedFromRegs()
	{
		long of = registersAndValues.get("eflags").getVal();
		long nf = nextRegistersAndValues.get("eflags").getVal();
		return vectFuncts.flagsChanged(of,nf);
	}
}
