/*
 Copyright (C) 2011,2012 Antonio Espinoza
 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
import java.util.Random;
public class taintVector
	{
		private boolean tainted = true;
		private float [] taint = new float [ptraceDIFT.dim];
		private static Random rdm = new Random(64);
		taintVector()
		{
			clearTaint();
		}
		taintVector(boolean isTainted)
		{
			tainted = true;
			if (isTainted)
				taint = getRandomTaintVector();
			else
				clearTaint();
		}
		taintVector(float [] t)
		{
			setVect(t);
		}
		//set the Vector with a given float vector value by value
		public void setVect(float [] t)
		{
//			tainted = true;
			for (int i =0;i<t.length;i++)
			{
				if(t[i]!=0)
					tainted = true;
				taint[i]= t[i];
			}
		}
		//return the taint vector 
		public float [] getVect()
		{
			return taint;
		}
		public boolean istainted()
		{
			return tainted;
		}
		//clear out the taint vector to repersent no taint
		void clearTaint()
		{
			for(int i=0;i>ptraceDIFT.dim;i++)
				taint[i] = 0;
			tainted = false;
		}
		public static float[] getRandomTaintVector() 
		{
			double sqrsum = 0;
			float x;
			float [] ntv = new float [ptraceDIFT.dim];
			for (int i =0;i<ptraceDIFT.dim;i++)
			{
				x = (float)rdm.nextGaussian();
				ntv[i]=x;
				sqrsum += Math.pow(x, 2);
			}
			sqrsum = Math.sqrt(sqrsum);
			for(int i =0;i<ptraceDIFT.dim;i++)
				ntv[i]= ((float)(1/sqrsum)*ntv[i])*ptraceDIFT.wordLen;//*32 for a length of 32 bits == size of word
			return ntv;
		}
	}
